SystemOrganization addCategory: #'P4-TAC'!
SystemOrganization addCategory: #'P4-TAC-IR'!
SystemOrganization addCategory: #'P4-TAC-Stream'!
SystemOrganization addCategory: #'P4-TAC-Values'!

P4Object subclass: #P4A2THelper
	instanceVariableNames: 'builder methodCompiler resultVariable groundTypes inlinedMethods asm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

!P4A2THelper methodsFor: 'convenience' stamp: 'ToonVerwaest 5/25/2011 17:51'!
annotation: anAnnotation! !

!P4A2THelper methodsFor: 'arguments' stamp: 'CamilloBruni 4/10/2012 18:53'!
arg: num of: total
	^ P4TACArgument 
			register: (asm callRegister: num of: total) 
			name: 'arg', num asString! !

!P4A2THelper methodsFor: 'accessing' stamp: 'CamilloBruni 3/29/2012 13:27'!
asm: anObject
	asm := anObject! !

!P4A2THelper methodsFor: 'accessing' stamp: 'CamilloBruni 3/29/2012 13:27'!
builder: aBuilder
	builder := aBuilder.
	resultVariable := builder resultVariable: asm resultVariable.
	inlinedMethods builder: builder.! !

!P4A2THelper methodsFor: 'convenience' stamp: 'OliFlueckiger 7/21/2011 11:34'!
currentHost: aMethod  ! !

!P4A2THelper methodsFor: 'optimizations' stamp: 'OliFlueckiger 8/24/2011 10:42'!
implements: aSelector
	^ inlinedMethods implements: aSelector! !

!P4A2THelper methodsFor: 'initialize-release' stamp: 'OliFlueckiger 8/29/2011 12:53'!
initialize
	groundTypes := false.
	inlinedMethods := P4TACInlineMessages new
							builder: builder;
							helper: self.! !

!P4A2THelper methodsFor: 'typeChecking' stamp: 'CamilloBruni 4/12/2012 16:18'!
inlineCacheHitCheck: method

	^ self 
		inlineCacheHitCheck: method host 
		for: (self arg: 1 of: methodCompiler numArgs) 
		fallbackLabel: (method invokeBlock: builder nextBasicBlock)! !

!P4A2THelper methodsFor: 'typeChecking' stamp: 'CamilloBruni 6/14/2012 17:16'!
inlineCacheHitCheck: host for: receiver fallbackLabel: invokeBlock

	| phost |

	phost := host inPharo.
	
	(builder testBit: 0 on: receiver)	
		description: 'is the receiver a tagged integer?'.
	
	phost == P4SmallInteger	ifTrue: [
		"the current method is on SmallInteger but the receiver 
		 is not an integer since the previous bit test failed ..."
		^ (builder jumpNoCarry: invokeBlock)
			description: 'invoking a SmallInteger method but non SmallInteger receiver' ].
		
	(P4SmallInteger inheritsFrom: phost) ifTrue: [
		 "current method is on P4Object"
		 ^ self inlineCacheInvoke: invokeBlock receiver: receiver ].
	
	(builder jumpCarry: invokeBlock)	
		description: 'receiver is an Integer but the method is not on SmallInteger'.
	
	(builder 
		compare: receiver accessClass 
		to: self typeVariable)
		description: 'inline cache type check: compare the receiver with the class in the typeVariable register'.
		
	(builder jumpNotEqual: invokeBlock)
		description: 'if the receiver and the expected class do not match run the slow lookup'! !

!P4A2THelper methodsFor: 'typeChecking' stamp: 'CamilloBruni 4/13/2012 14:18'!
inlineCacheInvoke: invokeBlock receiver: receiver
	"current method is on P4Object"
	| endBlock taggedBlock |
	
	self halt. 
	taggedBlock := builder nextBasicBlock.
	endBlock := builder nextBasicBlock.
	
	"current receiver is a SmallInteger => invoke the tagged integer block"
	builder shortJumpCarry: taggedBlock.
	
	"test if the inline cache hits"
	builder 
		compare: receiver accessClass 
		to: self typeVariable.
	"miss => do a standard lookup"
	builder jumpNotEqual: invokeBlock.
	"match => directly continue code evaluation"
	builder shortJump: endBlock.
	
	"output the tagged block"
	builder useAsNextBasicBlock: taggedBlock.
	
	"check if the current class is P4SmallInteger..."
	self flag: 'cami: this is not completely clear what happens here...'.
	builder 
		compare: (P4TACExternalReference target: P4SmallInteger asPClass theBehavior) 
		to: self typeVariable.
	"..."
	builder jumpNotEqual: invokeBlock.
	
	^ builder useAsNextBasicBlock: endBlock! !

!P4A2THelper methodsFor: 'typeChecking' stamp: 'OliFlueckiger 8/29/2011 11:51'!
insertCondition: consitions fallback: aFallback
	self insertCondition: consitions fallback: aFallback block: builder nextBasicBlock.! !

!P4A2THelper methodsFor: 'typeChecking' stamp: 'CamilloBruni 4/13/2012 14:19'!
insertCondition: conditions fallback: aFallback block: fallbackBlock
	| endBlock |
	endBlock := builder nextBasicBlock.
	
	(conditions includes: #carry) 
		ifTrue: [ builder shortJumpCarry: fallbackBlock ].  
	
	"we just assume that the fallback will not be more than a small jump away. this should be the case since the fallback will normally just call a function"
	builder shortJump: endBlock.
	
	builder useAsNextBasicBlock: fallbackBlock.
	aFallback value.
	
	builder useAsNextBasicBlock: endBlock.! !

!P4A2THelper methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/28/2011 12:31'!
insertMethodPreamble: method
	self inlineCacheHitCheck: method! !

!P4A2THelper methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 9/7/2011 14:40'!
insertPopArguments! !

!P4A2THelper methodsFor: 'typeChecking' stamp: 'CamilloBruni 4/12/2012 15:03'!
insertTypeGuard: types andCondition: conditions for: receiver around: aBlock fallback: aFallback
	| nextBlock codeBlock fallbackBlock lasType |
	
	builder volatileFence.
	codeBlock := builder nextBasicBlock.
	fallbackBlock := builder nextBasicBlock.
	
	types allButLastDo: [ :type|
		nextBlock := builder nextBasicBlock.
		type inPharo ~~ P4SmallInteger 
			ifTrue: [ builder move: (builder loadConstant: type theBehavior) to: self typeVariable ].
		self inlineCacheHitCheck: type for: receiver fallbackLabel: nextBlock.
		builder shortJump: codeBlock.  
		builder useAsNextBasicBlock: nextBlock].
	
	lasType := types last.
	
	lasType inPharo ~~ P4SmallInteger 
		ifTrue: [ builder move: (builder loadConstant: lasType theBehavior) to: self typeVariable ].
	self inlineCacheHitCheck: lasType for: receiver fallbackLabel: fallbackBlock.
	
	builder useAsNextBasicBlock: codeBlock.  
	aBlock value.
	
	self insertCondition: conditions fallback: aFallback block: fallbackBlock.! !

!P4A2THelper methodsFor: 'arguments' stamp: 'CamilloBruni 4/12/2012 15:04'!
intermediate
	^ P4TACFixedVariable 
		register: (asm intermediateRegisters at: 2)
		name: #intermediate! !

!P4A2THelper methodsFor: 'arguments' stamp: 'CamilloBruni 4/12/2012 15:04'!
intermediateLValue
	^ P4TACFixedVariable 
		register: (asm intermediateRegisters at: 1)
		name: #intermediateLValue! !

!P4A2THelper methodsFor: 'convenience' stamp: 'OliFlueckiger 8/31/2011 16:38'!
invoke: message for: receiver with: arguments
	"load selector"
	builder move: (builder loadConstant: message selector) to: self selectorVariable.
	builder invoke: message numOfArguments.
! !

!P4A2THelper methodsFor: 'visitor' stamp: 'CamilloBruni 6/14/2012 16:58'!
invokeBlockFor: method
	method invokeBlock 
		<< ((builder loadConstant: method selector ) moveTo: self resultVariable);
		<< (P4TACJump to: (P4Object earlySelectorAddress: #invoke:)).! !

!P4A2THelper methodsFor: 'convenience' stamp: 'CamilloBruni 4/10/2012 19:01'!
loadArguments: arguments andReceiver: receiver toSend: message
	| nativeArgsize |
	"the first argument is the receiver/self hence nativeArgsize := args + 1"
	nativeArgsize := arguments size + 1.
	
	builder move: receiver to: (self arg: 1 of: nativeArgsize).

	arguments withIndexDo: [ :arg :index |
		builder
			move: arg
			to: (self arg: index + 1 of: nativeArgsize) ].
	! !

!P4A2THelper methodsFor: 'convenience' stamp: 'CamilloBruni 4/12/2012 15:04'!
loadMethodArguments: parameters
	| theSelf numOfArgs aLocal i |

	"arg 1 is the caller class"
	numOfArgs := parameters size + 1.
	
	theSelf := builder local: #self.  
	builder move: ( self arg: 1 of: numOfArgs ) to: theSelf.
	i := 0.
	parameters do: [ :arg |
		aLocal := builder declare: arg name.
		i := i + 1.
		builder move: ( self arg: i + 1 of: numOfArgs ) to: aLocal ]. 
	
	builder volatileFence! !

!P4A2THelper methodsFor: 'accessing' stamp: 'ToonVerwaest 5/25/2011 18:07'!
methodCompiler: anObject
	methodCompiler := anObject! !

!P4A2THelper methodsFor: 'convenience' stamp: 'CamilloBruni 12/14/2011 17:01'!
methodReturn: aReturnExpression
	| ret |
	ret := aReturnExpression value accept: methodCompiler.
	builder return: ret.
	^ ret! !

!P4A2THelper methodsFor: 'accessing' stamp: 'ToonVerwaest 5/28/2011 18:33'!
resultVariable
	^ resultVariable! !

!P4A2THelper methodsFor: 'accessing' stamp: 'OliFlueckiger 9/7/2011 12:35'!
selectorVariable
	^ resultVariable ! !

!P4A2THelper methodsFor: 'optimizations' stamp: 'OliFlueckiger 8/24/2011 10:42'!
send: aMessage to: aReceiver with: theArguments for: aVisitor
	^ inlinedMethods send: aMessage to: aReceiver with: theArguments for: aVisitor! !

!P4A2THelper methodsFor: 'arguments' stamp: 'CamilloBruni 4/12/2012 15:04'!
stackPointer 
	^ P4TACFixedVariable 
		register: (asm stackPointer)
		name: #stack! !

!P4A2THelper methodsFor: 'accessing' stamp: 'OliFlueckiger 9/7/2011 12:35'!
typeVariable
	^ resultVariable! !

!P4A2THelper methodsFor: 'convenience' stamp: 'CamilloBruni 4/12/2012 15:05'!
unrollPrimitiveFor: callable 
	| code |
	
	callable isPrimitive ifFalse: [^self].
	code := callable primitiveCalling.
	code positionAtBeginning.
	
	builder 
		directCall: callable primitive;
		compare: (P4TACConstant with: 0) to: self resultVariable;
		jumpEqual: callable entry;
		return: self resultVariable ! !

P4A2THelper subclass: #P4A2TStatic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

P4A2TStatic subclass: #P4A2TKernel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

P4A2TKernel subclass: #P4A2TInvoke
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

!P4A2TInvoke methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 6/15/2012 17:45'!
insertMethodPreamble: method
	method invokeBlock: builder nextBasicBlock.
	asm callRegisters reverseDo: [ :r | builder push: r ]! !

!P4A2TInvoke methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2012 13:27'!
insertPopArguments
	asm callRegisters do: [ :r | builder pop: r ]! !

!P4A2TInvoke methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/24/2011 14:57'!
loadMethodArguments: parameters
	| theSelf paramName |
	"invoke gets the only 1 arg (the selector) "
	
	theSelf := builder self.
	builder move: ( self arg: 1 of: 1 ) to: theSelf.
	
	paramName := parameters first name.
	builder declare: paramName.
	builder move: self selectorVariable to: (builder local: paramName).
	
	builder volatileFence! !

!P4A2TKernel methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/18/2011 12:15'!
annotation: annotation
	( annotation selector == #fixedType:as: ) ifTrue: [
		self staticType: annotation arguments first symbol as: annotation arguments second symbol ].
	( annotation selector == #typeHint:as: ) ifTrue: [
		self typeHint: annotation arguments first symbol as: annotation arguments second symbol ].
	( annotation selector == #rename: ) ifTrue: [ 
		methodCompiler method selector: annotation arguments first symbol  ].
	( annotation selector == #globalName: ) ifTrue: [
		methodCompiler method codeUid: annotation arguments first symbol ].
	( annotation selector == #pprimitive: ) ifTrue: [
		methodCompiler method primitive: annotation arguments first symbol ].
	( annotation selector == #renameExport: ) ifTrue: [
		methodCompiler method selector: annotation arguments first symbol ].
	( annotation selector == #groundTypes ) ifTrue: [
		groundTypes := true ].! !

!P4A2TStatic methodsFor: 'convenience' stamp: 'OliFlueckiger 7/22/2011 16:13'!
currentHost: host 
	(host inPharo class canPerform: #typeHints) ifTrue: [
		host inPharo typeHints keysAndValuesDo: [ :name :type |
			self typeHint: name as: type]]! !

!P4A2TStatic methodsFor: 'hardwired-calls' stamp: 'CamilloBruni 12/14/2011 16:02'!
insertTypeGuardForCall: method expected: aType
	| receiver |
	self 
		insertTypeGuard: {aType}
		andCondition: {}
		for: (self arg: 1 of: methodCompiler numArgs)
		around: [
			builder 
				directCallSkipTypeCheck: method earlySelectorAddress 
				on: method pMethodClass.]
		fallback: [
			builder 
				move: (builder loadConstant: method selector) to: self resultVariable;
				invoke: method numArgs.]! !

!P4A2TStatic methodsFor: 'visitor' stamp: 'CamilloBruni 4/10/2012 19:07'!
invoke: message for: receiver with: arguments
	| method |
	
	receiver hasTypeHint ifTrue: [
		^ self invokeTyped: message for: receiver with: arguments ].
	
	receiver isStaticallyTyped ifTrue: [
		^ self invokeStatic: message for: receiver with: arguments ].
	
	^ super invoke: message for: receiver with: arguments.! !

!P4A2TStatic methodsFor: 'visitor' stamp: 'CamilloBruni 4/10/2012 19:07'!
invokeStatic: message for: receiver with: arguments
	
	| method |
	
	method := receiver staticType pLookupSelector: message selector.
	^ builder 
		directCallSkipTypeCheck: method earlySelectorAddress   
		on: method pMethodClass! !

!P4A2TStatic methodsFor: 'visitor' stamp: 'CamilloBruni 4/10/2012 19:06'!
invokeTyped: message for: receiver with: arguments
	
	| method|
	
	groundTypes ifFalse: [	
		builder move: (builder loadConstant: receiver typeHint) to: self typeVariable.
		^ builder directCall: (receiver typeHint earlySelectorAddress: message selector) ] .
		
	(receiver hasTypeHint) ifTrue: [ 
		method := receiver typeHint pLookupSelector: message selector.
		^ self insertTypeGuardForCall: method expected: receiver typeHint ].! !

!P4A2TStatic methodsFor: 'convenience' stamp: 'OliFlueckiger 7/22/2011 16:16'!
resolve: classPath
	^P4Package byPathName: classPath! !

!P4A2TStatic methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 14:58'!
staticType: variable as: type
		(builder localOrInstVar: variable) staticType: (self resolve: type). ! !

!P4A2TStatic methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 14:58'!
typeHint: variable as: type
	(builder localOrInstVar: variable) typeHint: (self resolve: type).  
! !

P4Object subclass: #P4TACBuilder
	instanceVariableNames: 'currentBasicBlock locals temps instVars instVarsIdx literals resultVariable globals method selfImport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:07'!
add: value to: aVariable
	^ currentBasicBlock << (P4TACAdd a: value to: aVariable)! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 7/19/2011 17:34'!
addGlobal: anObject
	^ globals at: anObject name asSymbol  put: (P4TACExternalReference target: anObject )! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:07'!
and: value with: aVariable
	^ currentBasicBlock << (P4TACAnd a: value to: aVariable)! !

!P4TACBuilder methodsFor: 'helper' stamp: 'OliFlueckiger 9/6/2011 16:52'!
bitShift: target by: num
	currentBasicBlock << P4TACBitShift new target: target; bits: num! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'CamilloBruni 6/15/2012 13:31'!
classReferenceFor: aName
	| aClass |
	aClass := (Smalltalk globals at: aName ifAbsent: [ self error: 'Undeclared class ', aName ]) asPClass.
	^ (self loadConstant: aClass)
		name: aName
! !

!P4TACBuilder methodsFor: 'initialize-release' stamp: 'OliFlueckiger 8/24/2011 15:21'!
clearInstVars
	instVars removeAll.! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'OliFlueckiger 8/31/2011 17:53'!
closure: aClosure inScope: aCallable
	| closure capture temp |
	temp := self nextClosureTemp.
	closure := P4TACClosure new.
	closure code: aClosure.
	closure outerScope: aCallable.
	capture := P4TACCaptureClosure new.
	capture closure: closure.
	capture capturedAt: currentBasicBlock.
	capture resultVariable: temp.
	currentBasicBlock << capture.
	^ capture! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:07'!
compare: value to: aVariable
	^ currentBasicBlock << (P4TACCompare a: value to: aVariable)! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'OliFlueckiger 5/10/2011 18:08'!
currentBasicBlock
	^ currentBasicBlock
! !

!P4TACBuilder methodsFor: 'helper' stamp: 'OliFlueckiger 8/11/2011 18:09'!
declare: variableName
	^ locals at: variableName ifAbsentPut: (P4TACLocal named: variableName)! !

!P4TACBuilder methodsFor: 'helper' stamp: 'OliFlueckiger 8/24/2011 14:47'!
declareInstVars: someInstVars
	| index |
	index := 0.
	someInstVars do: [ :v |
		instVarsIdx at: v asSymbol put: index.
		index := index + 1 ]! !

!P4TACBuilder methodsFor: 'helper' stamp: 'ToonVerwaest 5/26/2011 17:21'!
declareLocals: someLocals
	| name |
	someLocals do: [ :v |
		name := v name asSymbol.
		self declare: name.  
	]! !

!P4TACBuilder methodsFor: 'helper' stamp: 'OliFlueckiger 6/9/2011 21:17'!
declareSelf: variableName
	^ locals at: variableName put: (P4TACSelf named: variableName)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:08'!
directCall: aSymbol
	^ currentBasicBlock << (P4TACCall to: aSymbol)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:08'!
directCallSkipTypeCheck: aSymbol on: type
	^ currentBasicBlock << ((P4TACCall to: aSymbol) offset: type typeCheckByteSize)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:08'!
directReturn: value
	self move: value to: resultVariable.
	^ currentBasicBlock << P4TACReturn new noTeardown
! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:08'!
endBlock
	currentBasicBlock nextBlock ifNotNil: [ self error: 'Trying to end non-final block' ].
	^ currentBasicBlock nextBlock: P4TACEndBlock new! !

!P4TACBuilder methodsFor: 'globals' stamp: 'ToonVerwaest 8/5/2011 12:41'!
false
	^ globals at: #false! !

!P4TACBuilder methodsFor: 'helper' stamp: 'CamilloBruni 4/12/2012 16:20'!
firstBasicBlock
self halt.
	^ currentBasicBlock := P4TACBasicBlock index: 1  
	! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'OliFlueckiger 7/15/2011 14:37'!
global: aGlobal
	^ globals at: aGlobal! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:08'!
indirectCall: target
	^ currentBasicBlock << (P4TACIndirectCall to: target)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:08'!
indirectJump: target
	^ currentBasicBlock << (P4TACIndirectJump to: target)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:08'!
indirectTailJump: target
	^ currentBasicBlock 
		<< P4TACTeardown new;
		<< (P4TACIndirectJump to: target)! !

!P4TACBuilder methodsFor: 'initialize-release' stamp: 'OliFlueckiger 8/24/2011 15:16'!
initialize
	literals := OrderedCollection new.
	instVars := IdentityDictionary new.
	instVarsIdx := IdentityDictionary new.
	locals := IdentityDictionary new.
	self initializeGlobals.! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 7/19/2011 17:33'!
initializeGlobals
	globals := P4IdentityDictionary new.
	self 
		addGlobal: nil;
		addGlobal: true;
		addGlobal: false.! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'CamilloBruni 6/15/2012 13:32'!
instVar: aName
	^self instVar: aName ifAbsent: [
		self error: '"', aName asString, '" is not an instVar']! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'CamilloBruni 6/15/2012 13:24'!
instVar: aName ifAbsent: aBlock
	^ instVars at: aName ifAbsentPut: [
		instVarsIdx at: aName 
			ifPresent: [ :i | 
				(self self accessAt: i)
					name: aName ]
			ifAbsent: aBlock ]! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'OliFlueckiger 8/24/2011 14:51'!
instVarOrGlobal: aName
	^ self instVar: aName ifAbsent: [ 
		globals at: aName ifAbsent: [
			(aName at: 1) isUppercase 
				ifTrue: [ self classReferenceFor: aName ]
				ifFalse: [ self error: 'Unknown variable: ', aName ]]]
! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:08'!
intAdd: value to: aVariable
	^ currentBasicBlock 
		<< (P4TACXOr a: (P4TACConstant with: 1) to: aVariable);
		<< (P4TACAdd a: value to: aVariable)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:08'!
intSub: value from: aVariable
	^ currentBasicBlock 
		<< (P4TACSub a: value to: aVariable);
		<< (P4TACOr a: (P4TACConstant with: 1) to: aVariable)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:09'!
invoke: n
	^ currentBasicBlock << (P4TACCall to: (P4Object earlySelectorAddress: #invoke:) )! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:09'!
jump: target
	^ currentBasicBlock << (P4TACJump to: target)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:09'!
jumpCarry: target
	^ currentBasicBlock << ((P4TACJump to: target) carry)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:09'!
jumpEqual: target
	^ currentBasicBlock << ((P4TACJump to: target) equals)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:09'!
jumpNoCarry: target
	^ currentBasicBlock << ((P4TACJump to: target) noCarry)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:09'!
jumpNotEqual: target
	^ currentBasicBlock << ((P4TACJump to: target) notEquals)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'ToonVerwaest 8/5/2011 12:28'!
literalFrameIndex: aConstant	
	literals add: aConstant.
	^ literals size.! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'OliFlueckiger 5/12/2011 17:19'!
literals
	^ literals! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 4/10/2012 19:09'!
loadConstant: aConstant
	| index |
	index := self literalFrameIndex: aConstant.
	^ method accessAt: index! !

!P4TACBuilder methodsFor: 'helper' stamp: 'OliFlueckiger 8/24/2011 14:53'!
loadSelf: variableName from: aBlock
	selfImport := aBlock! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'OliFlueckiger 5/31/2011 16:45'!
local: aName
	^ locals
		at: aName
		ifAbsent: [ self error: 'no such local variable' ]! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'OliFlueckiger 6/9/2011 20:31'!
local: aName ifAbsent: aBlock
	^ locals
		at: aName
		ifAbsent: aBlock! !

!P4TACBuilder methodsFor: 'helper' stamp: 'CamilloBruni 6/15/2012 13:32'!
localOrInstVar: aName
	| temp |
	^ self local: aName ifAbsent: [
		self instVar: aName ifAbsent: [ 
			self error: 'no such local or intsance variable'] ].! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 5/26/2011 18:08'!
locals: aDictionary
	locals := aDictionary! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:09'!
move: aTACValue to: aTACVariable
	^ currentBasicBlock << (aTACValue moveTo: aTACVariable ).! !

!P4TACBuilder methodsFor: 'helper' stamp: 'OliFlueckiger 5/24/2011 16:51'!
nextBasicBlock
	^ P4TACBasicBlock new
	! !

!P4TACBuilder methodsFor: 'helper' stamp: 'OliFlueckiger 8/31/2011 17:54'!
nextClosureTemp
	^ temps add: (P4TACClosureTemp named: ('closureTmp', temps size asString)).! !

!P4TACBuilder methodsFor: 'helper' stamp: 'OliFlueckiger 6/9/2011 17:12'!
nextTemp
	^ temps add: (P4TACTemp named: ('tmp', temps size asString)).! !

!P4TACBuilder methodsFor: 'globals' stamp: 'ToonVerwaest 8/5/2011 12:41'!
nil
	^ globals at: #nil! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:10'!
or: value with: aVariable
	^  currentBasicBlock << (P4TACOr a: value to: aVariable)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'OliFlueckiger 8/24/2011 11:37'!
pHalt
	currentBasicBlock << P4TACHalt new.
	^ self loadConstant: nil.  ! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:10'!
pop: register
	^ currentBasicBlock << register pop! !

!P4TACBuilder methodsFor: 'helper' stamp: 'CamilloBruni 4/10/2012 18:47'!
postamble
	^ currentBasicBlock := P4TACBasicBlock index: -1
! !

!P4TACBuilder methodsFor: 'helper' stamp: 'CamilloBruni 4/10/2012 18:47'!
preamble
	^ currentBasicBlock := P4TACBasicBlock index: 0
! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:10'!
push: register
	^ currentBasicBlock << register push! !

!P4TACBuilder methodsFor: 'initialize-release' stamp: 'OliFlueckiger 8/24/2011 15:15'!
reset
	literals removeAll.
	instVars removeAll.
	instVarsIdx removeAll.
	locals removeAll.! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 5/28/2011 18:37'!
resultVariable: aRegister
	^ resultVariable := P4TACResultVariable withRegister: aRegister! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:10'!
return: value
	self move: value to: resultVariable.
	^ currentBasicBlock << P4TACReturn new
! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'OliFlueckiger 8/24/2011 15:06'!
self
	^ locals at: #self ifAbsent: selfImport! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'OliFlueckiger 6/16/2011 13:53'!
setMethodObject: aCallable
	method := aCallable methodObject  ! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:10'!
shortJump: target
	^ currentBasicBlock << ((P4TACJump to: target) short)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:10'!
shortJumpCarry: target
	^ currentBasicBlock << ((P4TACJump to: target) carry; short)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:10'!
shortJumpEqual: target
	^ currentBasicBlock << ((P4TACJump to: target) equals; short)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:10'!
shortJumpNoCarry: target
	^ currentBasicBlock << ((P4TACJump to: target) noCarry; short)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:10'!
shortJumpNotEqual: target
	^ currentBasicBlock << ((P4TACJump to: target) notEquals; short)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:11'!
tailJump: target
	^ currentBasicBlock 
		<< P4TACTeardown new;
		<< (P4TACJump to: target)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:12'!
teardown
	^ currentBasicBlock 
		<< P4TACTeardown new! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:12'!
teardownToPerform
	^ currentBasicBlock 
		<< P4TACTeardown new keepArguments! !

!P4TACBuilder methodsFor: 'helper' stamp: 'OliFlueckiger 6/9/2011 20:52'!
temporaryStore: aValue
	| temp |
	aValue isConstant ifTrue: [ ^ aValue ].
	temp := self nextTemp.
	self move: aValue to: temp.
	^ temp! !

!P4TACBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 5/28/2011 14:31'!
temps: aCollection
	temps := aCollection! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:12'!
test: value with: aVariable
	^ currentBasicBlock << (P4TACTest a: value to: aVariable)! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:12'!
testBit: num on: aVariable
	^ currentBasicBlock << (P4TACBitTest of: num in: aVariable)! !

!P4TACBuilder methodsFor: 'globals' stamp: 'ToonVerwaest 8/5/2011 12:39'!
true
	^ globals at: #true! !

!P4TACBuilder methodsFor: 'helper' stamp: 'OliFlueckiger 9/6/2011 16:52'!
untag: target
	currentBasicBlock << P4TACBitShiftRight new target: target; bits: 1! !

!P4TACBuilder methodsFor: 'helper' stamp: 'CamilloBruni 4/12/2012 16:23'!
useAsNextBasicBlock: aBlock
	currentBasicBlock ifNotNil: [ 
		^ currentBasicBlock := currentBasicBlock nextBlock: aBlock ].
	aBlock index: 0.
	currentBasicBlock := aBlock 
! !

!P4TACBuilder methodsFor: 'tac-value-builder' stamp: 'CamilloBruni 6/14/2012 17:12'!
volatileFence
	^ currentBasicBlock << P4TACVolatileFence new.
! !

P4Object subclass: #P4TACCodePoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

P4TACCodePoint subclass: #P4TACCodeBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

P4TACCodeBlock subclass: #P4ObjectStream
	instanceVariableNames: 'instructions currentPosition substreams'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Stream'!

P4ObjectStream subclass: #P4EmptyStreamObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Stream'!

P4EmptyStreamObject class
	instanceVariableNames: 'instance'!

P4EmptyStreamObject class
	instanceVariableNames: 'instance'!

!P4EmptyStreamObject class methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/8/2011 16:57'!
instance
	^ instance ifNil: [ ^ instance := self new ]! !

!P4EmptyStreamObject methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/8/2011 18:31'!
do: aBlock! !

!P4EmptyStreamObject methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/8/2011 18:32'!
printOn: aStream! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 18:32'!
<< anObject
	^ anObject putObjectOn: self! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 15:04'!
do: aBlock
	instructions do: [ :instr |
		instr do: aBlock ].! !

!P4ObjectStream methodsFor: 'private' stamp: 'OliFlueckiger 6/8/2011 15:00'!
doSubstreams: aBlock
	^ substreams do: aBlock! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 7/28/2011 12:08'!
firstElement
	self do: [ :instr |^ instr ]! !

!P4ObjectStream methodsFor: 'private' stamp: 'OliFlueckiger 6/8/2011 15:19'!
hasSubstreams
	^ substreams isEmpty not! !

!P4ObjectStream methodsFor: 'initialize-release' stamp: 'OliFlueckiger 6/8/2011 15:14'!
initialize 
	currentPosition := self.
	instructions := OrderedCollection new.
	substreams := OrderedCollection new.! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 15:25'!
isEmpty 
	^ instructions isEmpty ! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 15:53'!
lastElement
	self reverseDo: [ :instr | ^ instr ]! !

!P4ObjectStream methodsFor: 'private' stamp: 'OliFlueckiger 6/8/2011 18:31'!
newSubstream
	^ self newSubstream: P4ObjectStream new.! !

!P4ObjectStream methodsFor: 'private' stamp: 'OliFlueckiger 6/8/2011 15:14'!
newSubstream: aStream
	^ substreams add: aStream ! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 15:15'!
nextPut: aTacIR
	(currentPosition == self) ifTrue: [ ^ instructions add: aTacIR ].
	^ currentPosition nextPut: aTacIR! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 18:02'!
nextPutStream: aStream
	self newSubstream: aStream.
	^ currentPosition nextPut: aStream! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 18:07'!
overridePosition: anInstruction
	| index |
	index := instructions indexOf: anInstruction ifAbsent: [
		self hasSubstreams 
			ifTrue: [  
				self doSubstreams: [ :stream |
					(stream overridePosition: anInstruction) ifNotNil: [ 
						currentPosition := stream. 
						^self ]]].
			^nil].
	currentPosition := self newSubstream..
	instructions at: index put: currentPosition.
	^ self.! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 18:19'!
position: anInstruction
	^ (self overridePosition: anInstruction)
		ifNotNil: [ 
			self << anInstruction.
			^ self ]! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 17:02'!
position: anInstruction ifAbsent: aBlock
	(self position: anInstruction) ifNil: aBlock! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 18:27'!
positionAtBeginning
	currentPosition := instructions addFirst: self newSubstream.! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 15:15'!
positionAtEnd
	currentPosition := self! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 16:49'!
printOn: aStream
	self do: [ :instr | 
		aStream tab.
		instr printOn: aStream. ]! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 18:32'!
putObjectOn: anInstructionStream
	^ anInstructionStream nextPutStream: self! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 18:31'!
remove: anInstruction
	| index |
	index := instructions indexOf: anInstruction ifAbsent: [
		self hasSubstreams 
			ifTrue: [  
				self doSubstreams: [ :stream |
					(stream remove: anInstruction) ifNotNilDo: [ :instr | ^ instr ]]].
			^nil].
	instructions at: index put: P4EmptyStreamObject instance.
	^ anInstruction.! !

!P4ObjectStream methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 15:59'!
reverseDo: aBlock
	instructions reverseDo: [ :instr |
		instr do: aBlock ].! !

P4ObjectStream subclass: #P4TACBasicBlock
	instanceVariableNames: 'nextBlock index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACBasicBlock class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/10/2012 18:48'!
index: aNum
	^ self new index: aNum  ! !

!P4TACBasicBlock methodsFor: 'visitor accepting' stamp: 'OliFlueckiger 5/7/2011 14:22'!
accept: aVisitor
	^ aVisitor visitBasicBlock: self! !

!P4TACBasicBlock methodsFor: 'testing' stamp: 'ToonVerwaest 5/6/2011 19:55'!
atEnd
	^ false! !

!P4TACBasicBlock methodsFor: 'testing' stamp: 'OliFlueckiger 7/28/2011 12:09'!
firstElement 
	self isEmpty ifTrue: [ ^ nextBlock firstElement ].
	^ super firstElement! !

!P4TACBasicBlock methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2012 18:48'!
index
	^ index! !

!P4TACBasicBlock methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2012 18:48'!
index: aNumber
	index := aNumber! !

!P4TACBasicBlock methodsFor: 'accessing' stamp: 'OliFlueckiger 5/6/2011 11:43'!
nextBlock
	^ nextBlock! !

!P4TACBasicBlock methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2012 18:48'!
nextBlock: aBlock
	nextBlock := aBlock.
	nextBlock index: index + 1.
	^aBlock ! !

!P4TACBasicBlock methodsFor: 'printing' stamp: 'CamilloBruni 4/10/2012 18:48'!
printOn: stream
	stream << 'block ' << index asString << ':' << Character cr.
	super printOn: stream.  
	stream << Character cr.
	nextBlock printOn: stream.! !

!P4TACBasicBlock methodsFor: 'printing' stamp: 'CamilloBruni 4/10/2012 18:48'!
printString
	^ 'basicBlock-', index asString ! !

P4TACCodeBlock subclass: #P4TACCallable
	instanceVariableNames: 'preamble registerPushing argumentLoading primitiveCalling entry postamble popArguments invokeBlock locals temporaries frameSize usedRegisters remoteVariables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 7/25/2011 15:46'!
argumentLoading
	^ argumentLoading! !

!P4TACCallable methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2012 19:16'!
argumentLoading: anObject
	^ argumentLoading := anObject! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 8/29/2011 12:48'!
basePointer 
	^ self outerScope basePointer! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 9/8/2011 14:05'!
basePointerFor: asm2tac
	^ asm2tac visitVariable: P4TACBasePointerName instance! !

!P4TACCallable methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 15:37'!
basicBlocksDo: aBlock
	| currentBlock |
	currentBlock := preamble.
	[ currentBlock atEnd ] whileFalse: [
		aBlock value: currentBlock.
		currentBlock := currentBlock nextBlock ]
	! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 5/6/2011 11:44'!
entry
	^ entry! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 5/5/2011 01:03'!
entry: anEntry
	entry := anEntry .! !

!P4TACCallable methodsFor: 'accessing' stamp: 'CamilloBruni 4/3/2012 15:14'!
expungeUnusedLocals
	| names toRemove |
	
	"freeze the keys before we modify the locals"
	names := locals keys.
	names do: [ :name |
		(locals at: name) isUnused 
			ifTrue: [ locals removeKey: name ] ].
	
	toRemove := Set new.
	temporaries do: [ :aTemp | 
			aTemp isUnused ifTrue: [ toRemove add: aTemp ]].
	
	toRemove do: [ :aTemp | 
		temporaries remove: aTemp ].! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 8/5/2011 17:41'!
frameSize
    ^ frameSize + self stackAllignment! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 5/5/2011 00:51'!
frameSize: aFrameSize
	frameSize := aFrameSize ! !

!P4TACCallable methodsFor: 'accessing' stamp: 'ToonVerwaest 5/27/2011 17:42'!
hasLocal: aVariable
	^ locals includes: aVariable     ! !

!P4TACCallable methodsFor: 'initialize-release' stamp: 'ToonVerwaest 5/28/2011 15:13'!
initialize
	locals := IdentityDictionary new.
	temporaries := P4Set new.! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 7/28/2011 12:49'!
invokeBlock
	^ invokeBlock! !

!P4TACCallable methodsFor: 'accessing' stamp: 'CamilloBruni 6/15/2012 15:05'!
invokeBlock: aBasicBlock
	aBasicBlock index ifNil: [
		aBasicBlock index: 'inline-cache-miss'].
	^ invokeBlock := aBasicBlock! !

!P4TACCallable methodsFor: 'testing' stamp: 'ToonVerwaest 5/27/2011 17:16'!
is: variable lifeAfter: line
	liveness at: variable ifPresent: [ :ival |
		^ ival end > line ].
	^ false.! !

!P4TACCallable methodsFor: 'accessing' stamp: 'ToonVerwaest 5/26/2011 18:05'!
locals
	^ locals! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 9/7/2011 14:42'!
popArguments
	^ popArguments! !

!P4TACCallable methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2012 19:16'!
popArguments: anObject
	^ popArguments := anObject! !

!P4TACCallable methodsFor: 'accessing' stamp: 'ToonVerwaest 5/24/2011 18:39'!
postamble
	^ postamble! !

!P4TACCallable methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2012 19:18'!
postamble: anObject
	^ postamble := anObject! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 5/26/2011 14:50'!
preamble
	^ preamble! !

!P4TACCallable methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2012 19:18'!
preamble: anObject
	^ preamble := anObject! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 17:18'!
primitiveCalling
	^ primitiveCalling! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 17:18'!
primitiveCalling: anObject
	^ primitiveCalling := anObject! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 8/4/2011 18:04'!
registerPushing
	^ registerPushing! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 8/4/2011 18:06'!
registerPushing: anObject
	^ registerPushing := anObject! !

!P4TACCallable methodsFor: 'accessing' stamp: 'ToonVerwaest 5/27/2011 18:20'!
remoteVariables
	^ remoteVariables! !

!P4TACCallable methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2012 19:18'!
remoteVariables: anObject
	^ remoteVariables := anObject! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 9/8/2011 14:05'!
returnTokenFor: asm2tac
	^ asm2tac visitVariable: P4TACReturnTokenName instance! !

!P4TACCallable methodsFor: 'visiting' stamp: 'ToonVerwaest 5/6/2011 20:04'!
setupFrame: aVisitor
	^ aVisitor setupStaticFrame: self! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 8/5/2011 17:43'!
stackAllignment
	| realSize |
	realSize := (usedRegisters + frameSize + 1).
	self hasNonLocalReturn ifTrue: [ realSize := realSize + 1 ].
	^ realSize bitAnd: 1! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 6/9/2011 19:33'!
temps
	^ temporaries! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 5/7/2011 13:44'!
usedRegisters
	^ usedRegisters! !

!P4TACCallable methodsFor: 'accessing' stamp: 'OliFlueckiger 5/7/2011 13:44'!
usedRegisters: anObject
	usedRegisters := anObject! !

P4TACCallable subclass: #P4TACClosure
	instanceVariableNames: 'code outerScope imports'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACClosure methodsFor: 'accessing' stamp: 'OliFlueckiger 5/26/2011 18:02'!
accept: visitor
	visitor visitClosure: self ! !

!P4TACClosure methodsFor: 'accessing' stamp: 'ToonVerwaest 5/24/2011 17:51'!
code
	^ code! !

!P4TACClosure methodsFor: 'accessing' stamp: 'ToonVerwaest 5/24/2011 17:51'!
code: anObject
	code := anObject! !

!P4TACClosure methodsFor: 'accessing' stamp: 'OliFlueckiger 8/29/2011 12:51'!
export: aVariable
	locals at: aVariable ifPresent: [ :var | ^ var ].
	self import: aVariable.
	^ locals at: aVariable ifAbsent: [ nil ]! !

!P4TACClosure methodsFor: 'accessing' stamp: 'OliFlueckiger 8/4/2011 11:53'!
hasNonLocalReturn 
	^ false! !

!P4TACClosure methodsFor: 'accessing' stamp: 'ToonVerwaest 7/18/2011 21:56'!
import: aVariable
	| tacVariable |
	tacVariable := outerScope export: aVariable.
	tacVariable ifNil: [ ^ tacVariable ].
	imports add: tacVariable.
	^ locals at: aVariable put: tacVariable asAlias.! !

!P4TACClosure methodsFor: 'accessing' stamp: 'ToonVerwaest 5/26/2011 18:16'!
imports
	^ imports! !

!P4TACClosure methodsFor: 'initialize-release' stamp: 'ToonVerwaest 5/26/2011 18:22'!
initialize
	super initialize.
	imports := OrderedCollection new.! !

!P4TACClosure methodsFor: 'testing' stamp: 'ToonVerwaest 5/24/2011 17:56'!
isAssignment
	^ true! !

!P4TACClosure methodsFor: 'testing' stamp: 'ToonVerwaest 5/24/2011 17:59'!
isConstant
	^ true! !

!P4TACClosure methodsFor: 'accessing' stamp: 'OliFlueckiger 8/1/2011 16:34'!
methodFrameSize
	^ outerScope methodFrameSize! !

!P4TACClosure methodsFor: 'accessing' stamp: 'OliFlueckiger 6/16/2011 13:58'!
methodObject 
	^ outerScope methodObject ! !

!P4TACClosure methodsFor: 'testing' stamp: 'OliFlueckiger 6/7/2011 22:17'!
numOfArguments
	^ locals inject: 0 into: [ :size :var | var shouldBeRemote ifTrue: [ size ] ifFalse: [ size + 1 ]  ]! !

!P4TACClosure methodsFor: 'accessing' stamp: 'ToonVerwaest 5/24/2011 18:01'!
origin
	" ^ self "! !

!P4TACClosure methodsFor: 'accessing' stamp: 'ToonVerwaest 5/26/2011 17:48'!
outerScope
	^ outerScope! !

!P4TACClosure methodsFor: 'accessing' stamp: 'ToonVerwaest 5/26/2011 17:48'!
outerScope: anObject
	outerScope := anObject! !

P4TACCallable subclass: #P4TACMethod
	instanceVariableNames: 'host message literals closures uid codeUid methodObject asm primitive returnAddress nonLocalReturn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACMethod methodsFor: 'visitor accepting' stamp: 'OliFlueckiger 5/7/2011 14:22'!
accept: aVisitor
	^ aVisitor visitMethod: self! !

!P4TACMethod methodsFor: 'accessing' stamp: 'CamilloBruni 12/14/2011 17:08'!
addClosure: aBlock
	aBlock code containsReturn ifTrue: [ nonLocalReturn := true ].
	^ closures add: aBlock! !

!P4TACMethod methodsFor: 'accessing' stamp: 'CamilloBruni 5/30/2012 22:24'!
asm
	^ asm! !

!P4TACMethod methodsFor: 'accessing' stamp: 'CamilloBruni 5/30/2012 22:21'!
asm: anAssembler
	^ asm := anAssembler ! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 9/8/2011 14:05'!
basePointer
	^ self locals at: P4TACBasePointerName instance! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 7/5/2011 14:49'!
baseSize
	^ P4SmalltalkConfiguration objectHeaderSize + P4Method instSize + literals size! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 7/5/2011 14:51'!
byteSize
	^ codeStream pointerSize * self baseSize + self codeSize ! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 5/26/2011 16:41'!
closures
	^ closures! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 5/26/2011 16:41'!
closures: anObject
	closures := anObject! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 7/5/2011 14:50'!
codeSize
	^ codeStream size! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 7/8/2011 11:31'!
codeUid
	^ codeUid ifNil: [ uid := (host pfullName, '>>', self selector) asSymbol ]! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 6/15/2011 16:12'!
codeUid: anObject
	^ codeUid := anObject! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 8/4/2011 15:34'!
export: aVariable
	locals at: aVariable ifPresent: [ :var | ^ var ].
	^ nil! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 7/29/2011 07:59'!
frameSize: aFrameSize
	returnAddress ifNotNil: [ returnAddress index: aFrameSize + 1].
	super frameSize: aFrameSize  ! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 8/4/2011 11:40'!
hasNonLocalReturn
	^ nonLocalReturn! !

!P4TACMethod methodsFor: 'accessing' stamp: 'ToonVerwaest 5/17/2011 18:05'!
host
	^ host! !

!P4TACMethod methodsFor: 'accessing' stamp: 'ToonVerwaest 5/17/2011 18:05'!
host: anObject
	host := anObject! !

!P4TACMethod methodsFor: 'initialization' stamp: 'OliFlueckiger 8/4/2011 11:47'!
initialize
	super initialize.
	closures := OrderedCollection new.
	nonLocalReturn := false.! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 17:33'!
isPrimitive
	^ primitive isNil not! !

!P4TACMethod methodsFor: 'accessing' stamp: 'CamilloBruni 6/15/2012 18:03'!
label
	^ String streamContents: [ :s|
		s nextPutAll: self host inPinocchio name; nextPutAll: '>>'; print: self message]! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 5/12/2011 17:14'!
literals
	^ literals! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 5/12/2011 17:14'!
literals: anObject
	literals := anObject! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 5/16/2011 17:34'!
message 
	^ message! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 5/16/2011 17:34'!
message: aMessage
	message := aMessage ! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 8/1/2011 16:34'!
methodFrameSize
	^ self frameSize! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 7/14/2011 18:07'!
methodObject 
	^ methodObject ifNil: [ ^ methodObject := P4TACMethodObject new ].
! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 7/1/2011 15:25'!
numOfStringLiterals 
	^ (literals select: [ :l | l isString ]) size! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 17:32'!
primitive
	^ primitive! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 17:32'!
primitive: anObject
	primitive := anObject! !

!P4TACMethod methodsFor: 'printing' stamp: 'CamilloBruni 12/15/2011 13:21'!
printOn: stream
	stream << message! !

!P4TACMethod methodsFor: 'printing' stamp: 'OliFlueckiger 5/24/2011 14:57'!
printSource
	| currentBlock stream |
	currentBlock := entry.
	stream := Stream new.
	[ currentBlock isLast ] whileFalse: [
		currentBlock do: [ :instr |
			instr printOn: stream ]
	].
	^ stream asString! !

!P4TACMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 9/8/2011 14:05'!
returnToken  
	^ self locals at: P4TACReturnTokenName instance! !

!P4TACMethod methodsFor: 'accessing' stamp: 'CamilloBruni 12/14/2011 16:21'!
selector
	^ message! !

!P4TACMethod methodsFor: 'accessing' stamp: 'ToonVerwaest 5/26/2011 12:59'!
selector: aSelector
	message selector: aSelector! !

P4TACCodeBlock subclass: #P4TACEndBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACEndBlock methodsFor: 'testing' stamp: 'OliFlueckiger 5/7/2011 14:22'!
accept: aVisitor
	^ aVisitor visitEndBlock: self! !

!P4TACEndBlock methodsFor: 'testing' stamp: 'ToonVerwaest 5/6/2011 19:55'!
atEnd
	^ true! !

!P4TACEndBlock methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2012 18:48'!
index: aValue
	"ignore"! !

!P4TACEndBlock methodsFor: 'testing' stamp: 'OliFlueckiger 5/24/2011 15:18'!
printOn: stream
	stream << '---'! !

P4TACCodePoint subclass: #P4TACInstruction
	instanceVariableNames: 'flowNumber description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

P4TACInstruction subclass: #P4TACBitShift
	instanceVariableNames: 'target bits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACBitShift methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 9/6/2011 16:47'!
accept: aVisitor
	^ aVisitor visitBitShift: self! !

!P4TACBitShift methodsFor: 'accessing' stamp: 'OliFlueckiger 9/6/2011 16:47'!
bits
	^ bits! !

!P4TACBitShift methodsFor: 'accessing' stamp: 'OliFlueckiger 9/6/2011 16:47'!
bits: anObject
	bits := anObject! !

!P4TACBitShift methodsFor: 'accessing' stamp: 'OliFlueckiger 9/6/2011 16:47'!
target
	^ target! !

!P4TACBitShift methodsFor: 'accessing' stamp: 'OliFlueckiger 9/6/2011 16:47'!
target: anObject
	target := anObject! !

P4TACInstruction subclass: #P4TACBitShiftRight
	instanceVariableNames: 'target bits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACBitShiftRight methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 9/6/2011 16:46'!
accept: aVisitor
	^ aVisitor visitBitShiftRight: self! !

!P4TACBitShiftRight methodsFor: 'accessing' stamp: 'OliFlueckiger 9/6/2011 16:47'!
bits
	^ bits! !

!P4TACBitShiftRight methodsFor: 'accessing' stamp: 'OliFlueckiger 9/6/2011 16:47'!
bits: anObject
	bits := anObject! !

!P4TACBitShiftRight methodsFor: 'accessing' stamp: 'OliFlueckiger 9/6/2011 16:47'!
target
	^ target! !

!P4TACBitShiftRight methodsFor: 'accessing' stamp: 'OliFlueckiger 9/6/2011 16:47'!
target: anObject
	target := anObject! !

P4TACInstruction subclass: #P4TACBitTest
	instanceVariableNames: 'bit location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACBitTest class methodsFor: 'initialize-release' stamp: 'OliFlueckiger 6/17/2011 16:14'!
of: num in: var
	^ self new location: var; bit: num     ! !

!P4TACBitTest methodsFor: 'accessing' stamp: 'OliFlueckiger 6/17/2011 16:15'!
accept: aVisitor
	^ aVisitor visitBitTest: self! !

!P4TACBitTest methodsFor: 'accessing' stamp: 'OliFlueckiger 6/17/2011 16:13'!
bit
	^ bit! !

!P4TACBitTest methodsFor: 'accessing' stamp: 'OliFlueckiger 6/17/2011 16:13'!
bit: anObject
	bit := anObject! !

!P4TACBitTest methodsFor: 'accessing' stamp: 'OliFlueckiger 6/17/2011 16:13'!
location
	^ location! !

!P4TACBitTest methodsFor: 'accessing' stamp: 'OliFlueckiger 6/17/2011 16:13'!
location: anObject
	location := anObject! !

P4TACInstruction subclass: #P4TACCall
	instanceVariableNames: 'method offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACCall class methodsFor: 'instance creation' stamp: 'OliFlueckiger 5/26/2011 11:56'!
to: aMethod
	^ self new method: aMethod! !

!P4TACCall methodsFor: 'visiting' stamp: 'OliFlueckiger 5/26/2011 13:47'!
accept: aVisitor
	^ aVisitor visitCall: self! !

!P4TACCall methodsFor: 'accessing' stamp: 'OliFlueckiger 8/9/2011 18:37'!
initialize 
	super initialize .
	offset := 0! !

!P4TACCall methodsFor: 'accessing' stamp: 'OliFlueckiger 5/16/2011 17:08'!
method
	^ method! !

!P4TACCall methodsFor: 'accessing' stamp: 'OliFlueckiger 5/16/2011 17:08'!
method: anObject
	method := anObject! !

!P4TACCall methodsFor: 'accessing' stamp: 'OliFlueckiger 8/9/2011 18:37'!
offset
	^ offset! !

!P4TACCall methodsFor: 'accessing' stamp: 'OliFlueckiger 8/9/2011 18:37'!
offset: anObject
	offset := anObject! !

!P4TACCall methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/5/2011 16:13'!
printOn: stream
	self printLineNumberOn: stream.  
	stream << '[%rax] := call ' << method asString << Character cr.! !

P4TACInstruction subclass: #P4TACCaptureClosure
	instanceVariableNames: 'closure capturedAt resultVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACCaptureClosure methodsFor: 'visiting' stamp: 'OliFlueckiger 5/26/2011 16:35'!
accept: visitor
	^ visitor visitCaptureClosure: self! !

!P4TACCaptureClosure methodsFor: 'visiting' stamp: 'OliFlueckiger 5/31/2011 17:29'!
acceptCaptureClosure: visitor
	^ visitor visitCaptureClosure: self! !

!P4TACCaptureClosure methodsFor: 'accessing' stamp: 'OliFlueckiger 5/26/2011 16:31'!
capturedAt
	^ capturedAt! !

!P4TACCaptureClosure methodsFor: 'accessing' stamp: 'OliFlueckiger 5/26/2011 16:31'!
capturedAt: aBasicBlock
	capturedAt := aBasicBlock ! !

!P4TACCaptureClosure methodsFor: 'accessing' stamp: 'OliFlueckiger 5/26/2011 16:01'!
closure
	^ closure! !

!P4TACCaptureClosure methodsFor: 'accessing' stamp: 'OliFlueckiger 5/26/2011 16:01'!
closure: anObject
	closure := anObject! !

!P4TACCaptureClosure methodsFor: 'accessing' stamp: 'CamilloBruni 12/14/2011 17:09'!
containsReturn 
	^ closure code containsReturn! !

!P4TACCaptureClosure methodsFor: 'accessing' stamp: 'OliFlueckiger 8/5/2011 15:24'!
hasReturnExpression 
	^ closure code hasReturnExpression! !

!P4TACCaptureClosure methodsFor: 'visiting' stamp: 'OliFlueckiger 6/8/2011 17:11'!
printOn: stream
	self printLineNumberOn: stream.
	stream << '['.
	closure printOn: stream.
	stream << ']'<< Character cr.  ! !

!P4TACCaptureClosure methodsFor: 'accessing' stamp: 'OliFlueckiger 6/7/2011 18:50'!
resultVariable
	^ resultVariable! !

!P4TACCaptureClosure methodsFor: 'accessing' stamp: 'OliFlueckiger 6/7/2011 18:50'!
resultVariable: anObject
	resultVariable := anObject! !

P4TACInstruction subclass: #P4TACHalt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACHalt methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/24/2011 11:36'!
accept: aVisitor
	^ aVisitor visitHalt: self.! !

!P4TACHalt methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/25/2011 12:41'!
asValue 
	^ nil! !

!P4TACHalt methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/8/2011 17:11'!
printOn: stream
	self printLineNumberOn: stream.
	stream << 'halt' << Character cr.! !

P4TACInstruction subclass: #P4TACIndirectCall
	instanceVariableNames: 'register'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACIndirectCall class methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/31/2011 16:28'!
to: aTarget
	^ self new register: aTarget ! !

!P4TACIndirectCall methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/31/2011 16:27'!
accept: aVisitor
	^ aVisitor visitIndirectCall: self! !

!P4TACIndirectCall methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/31/2011 17:51'!
printOn: stream
	self printLineNumberOn: stream.  
	stream << 'call: *'.
	register printRegisterOn: stream.
	stream << Character cr.! !

!P4TACIndirectCall methodsFor: 'accessing' stamp: 'OliFlueckiger 8/31/2011 16:28'!
register
	^ register! !

!P4TACIndirectCall methodsFor: 'accessing' stamp: 'OliFlueckiger 8/31/2011 16:28'!
register: anObject
	register := anObject! !

P4TACInstruction subclass: #P4TACIndirectJump
	instanceVariableNames: 'register'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACIndirectJump class methodsFor: 'instance creation' stamp: 'OliFlueckiger 5/26/2011 14:12'!
to: aTarget
	^ self new register: aTarget ! !

!P4TACIndirectJump methodsFor: 'visiting' stamp: 'OliFlueckiger 5/24/2011 14:08'!
accept: aVisitor
	^ aVisitor visitIndirectJump: self! !

!P4TACIndirectJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/31/2011 17:51'!
printOn: stream
	self printLineNumberOn: stream.  
	stream << 'jump: *'.
	register printRegisterOn: stream.
	stream << Character cr.! !

!P4TACIndirectJump methodsFor: 'accessing' stamp: 'OliFlueckiger 5/24/2011 12:58'!
register
	^ register! !

!P4TACIndirectJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/24/2011 12:58'!
register: aRegister
	register := aRegister! !

!P4TACInstruction methodsFor: 'visiting' stamp: 'OliFlueckiger 5/7/2011 14:22'!
accept: aVisitor
	^ aVisitor visitInstruction: self! !

!P4TACInstruction methodsFor: 'visiting' stamp: 'OliFlueckiger 5/31/2011 17:29'!
acceptCaptureClosure: aVisitor
	
! !

!P4TACInstruction methodsFor: 'accessing' stamp: 'OliFlueckiger 5/12/2011 15:00'!
acceptRegisterSwapper: aVisitor
! !

!P4TACInstruction methodsFor: 'accessing' stamp: 'CamilloBruni 6/14/2012 17:06'!
description
	^ description! !

!P4TACInstruction methodsFor: 'accessing' stamp: 'CamilloBruni 6/14/2012 17:06'!
description: aString
	description := aString! !

!P4TACInstruction methodsFor: 'instruction-stream' stamp: 'OliFlueckiger 6/8/2011 15:04'!
do: aBlock
	aBlock value: self! !

!P4TACInstruction methodsFor: 'accessing' stamp: 'OliFlueckiger 5/7/2011 12:15'!
flowNumber
	^ flowNumber! !

!P4TACInstruction methodsFor: 'accessing' stamp: 'OliFlueckiger 5/7/2011 12:15'!
flowNumber: anObject
	flowNumber := anObject! !

!P4TACInstruction methodsFor: 'accessing' stamp: 'OliFlueckiger 5/7/2011 14:00'!
isAssignment
	^false! !

!P4TACInstruction methodsFor: 'accessing' stamp: 'OliFlueckiger 5/7/2011 12:20'!
printLineNumberOn: stream
	flowNumber isNil ifFalse: [ stream << flowNumber << ': ' ]! !

!P4TACInstruction methodsFor: 'instruction-stream' stamp: 'OliFlueckiger 6/8/2011 18:32'!
putObjectOn: anInstructionStream
	^ anInstructionStream nextPut: self! !

P4TACInstruction subclass: #P4TACJump
	instanceVariableNames: 'target zero carry short'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACJump class methodsFor: 'instance creation' stamp: 'OliFlueckiger 5/26/2011 12:04'!
to: aTarget
	^ self new target: aTarget ! !

!P4TACJump methodsFor: 'visiting' stamp: 'CamilloBruni 6/14/2012 17:19'!
accept: aVisitor
	self isConditional 
		ifTrue: [ ^ aVisitor visitConditionalJump: self ].
		
	^ aVisitor visitJump: self! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/17/2011 15:32'!
carry
	carry := true! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/17/2011 15:33'!
equals
	self zero! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/13/2012 16:16'!
ifCarrySet: aBlock
	^ carry ifTrue: aBlock
! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/17/2011 16:05'!
ifCarrySet: aBlock else: anotherBlock
	carry ifTrue: [ ^ aBlock value ].
	carry ifFalse: [ ^ anotherBlock value ].
! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/13/2012 16:16'!
ifCarryTest: aBlock
	^ carry ifNotNil: aBlock! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/17/2011 15:56'!
ifCarryTest: aBlock else: anotherBlock
	carry ifNil: [ ^ anotherBlock value ].
	^ aBlock value! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/13/2012 16:15'!
ifEqualsSet: aBlock
	^ zero ifTrue: aBlock! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/12/2011 15:08'!
ifEqualsSet: aBlock else: anotherBlock
	zero 
		ifTrue: [ ^ aBlock value ]
		ifFalse: [ ^ anotherBlock value ].! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/13/2012 16:15'!
ifEqualsTest: aBlock
	^ zero ifNotNil: aBlock! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/17/2011 15:56'!
ifEqualsTest: aBlock else: anotherBlock
	zero ifNil: [ ^ anotherBlock value ].
	^ aBlock value! !

!P4TACJump methodsFor: 'testing' stamp: 'CamilloBruni 4/13/2012 16:14'!
isCarrySet
	^ carry! !

!P4TACJump methodsFor: 'testing' stamp: 'CamilloBruni 4/13/2012 16:14'!
isCarryTest
	^ carry isNil not! !

!P4TACJump methodsFor: 'testing' stamp: 'CamilloBruni 4/13/2012 16:22'!
isConditional
	^ carry isNil not or: [ zero isNil not ]! !

!P4TACJump methodsFor: 'testing' stamp: 'CamilloBruni 4/13/2012 16:15'!
isEqualsSet
	^ zero! !

!P4TACJump methodsFor: 'testing' stamp: 'CamilloBruni 4/13/2012 16:13'!
isEqualsTest
	^ zero isNil not! !

!P4TACJump methodsFor: 'testing' stamp: 'OliFlueckiger 6/17/2011 17:06'!
isShort
	^ short isNil not and: [ short ]! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/17/2011 15:32'!
noCarry
	carry := false! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/17/2011 15:33'!
notEquals
	self notZero! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/17/2011 15:32'!
notZero
	zero := false! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/17/2011 19:02'!
printOn: stream
	self printLineNumberOn: stream.
	stream << 'jump'.
	self ifEqualsTest: [ self ifEqualsSet: [] else: [stream << 'Not']. stream << 'Equals'  ] else: [].
	self ifCarryTest: [ self ifCarrySet: [] else: [stream << 'No']. stream << 'Carry'  ] else: [].
	stream << ' ' << target printString << Character cr.
! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/17/2011 17:05'!
short
	short := true.! !

!P4TACJump methodsFor: 'accessing' stamp: 'ToonVerwaest 5/6/2011 19:54'!
target
	^ target! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/6/2011 16:22'!
target: aTarget
	target := aTarget! !

!P4TACJump methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/17/2011 15:55'!
zero
	zero := true! !

P4TACInstruction subclass: #P4TACNilInstruction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

P4TACNilInstruction class
	instanceVariableNames: 'instance'!

P4TACNilInstruction class
	instanceVariableNames: 'instance'!

!P4TACNilInstruction class methodsFor: 'singleton' stamp: 'OliFlueckiger 6/9/2011 18:49'!
instance
	^ instance ifNil: [ instance := self new ].! !

!P4TACNilInstruction methodsFor: 'instruction-stream' stamp: 'OliFlueckiger 6/9/2011 18:48'!
putObjectOn: aStream! !

P4TACInstruction subclass: #P4TACOperation
	instanceVariableNames: 'left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

P4TACOperation subclass: #P4TACAdd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACAdd methodsFor: 'visitor accepting' stamp: 'ToonVerwaest 6/14/2011 14:57'!
accept: aVisitor
	^ aVisitor visitAdd: self! !

!P4TACAdd methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 17:35'!
op
	^ #add! !

P4TACOperation subclass: #P4TACAnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACAnd methodsFor: 'visitor accepting' stamp: 'ToonVerwaest 6/14/2011 14:57'!
accept: aVisitor
	^ aVisitor visitAnd: self! !

!P4TACAnd methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 17:35'!
op
	^ #and! !

P4TACOperation subclass: #P4TACAssigning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACAssigning class methodsFor: 'instance creation' stamp: 'ToonVerwaest 6/14/2011 15:12'!
assign: value to: target
	self halt.
	^ self new origin: value; target: target! !

!P4TACAssigning class methodsFor: 'instance creation' stamp: 'OliFlueckiger 5/26/2011 13:53'!
move: value to: target
	^ self new origin: value; target: target! !

!P4TACAssigning methodsFor: 'visiting' stamp: 'ToonVerwaest 6/14/2011 15:15'!
asValue 
	self flag: 'Not sure if this is correct'.
	^ left! !

!P4TACAssigning methodsFor: 'testing' stamp: 'OliFlueckiger 5/7/2011 14:00'!
isAssignment 
	^true! !

!P4TACAssigning methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 15:05'!
left
	^ left! !

!P4TACAssigning methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 15:14'!
origin
	^ left! !

!P4TACAssigning methodsFor: 'accessing' stamp: 'OliFlueckiger 7/20/2011 18:39'!
origin: anOrigin
	self haltIf: anOrigin isNil.
	left := anOrigin ! !

!P4TACAssigning methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 15:06'!
right
	^ right! !

!P4TACAssigning methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 15:14'!
target
	^ right! !

!P4TACAssigning methodsFor: 'accessing' stamp: 'OliFlueckiger 7/20/2011 18:39'!
target: aTarget
	self haltIf: aTarget isNil.
	right := aTarget ! !

P4TACAssigning subclass: #P4TACAssignment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACAssignment methodsFor: 'visiting' stamp: 'ToonVerwaest 6/17/2011 15:13'!
accept: aVisitor
	^ aVisitor visitAssignment: self! !

!P4TACAssignment methodsFor: 'accessing' stamp: 'ToonVerwaest 6/17/2011 15:13'!
op
	^ #mov! !

P4TACAssigning subclass: #P4TACLoadAddress
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACLoadAddress class methodsFor: 'instance creation' stamp: 'ToonVerwaest 6/17/2011 15:10'!
load: aValue in: aTarget
	^ self new left: aValue; right: aTarget! !

!P4TACLoadAddress methodsFor: 'accessing' stamp: 'ToonVerwaest 6/17/2011 15:13'!
accept: aVisitor
	^ aVisitor visitLoadAddress: self! !

!P4TACLoadAddress methodsFor: 'accessing' stamp: 'ToonVerwaest 6/17/2011 15:07'!
op
	^ #lea! !

P4TACOperation subclass: #P4TACCompare
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACCompare methodsFor: 'accessing' stamp: 'OliFlueckiger 5/6/2011 21:32'!
accept: aVisitor
	^ aVisitor visitCompare: self! !

!P4TACCompare methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 14:46'!
op
	^ #cmp! !

!P4TACOperation class methodsFor: 'instance creation' stamp: 'ToonVerwaest 6/14/2011 15:12'!
a: left to: aRight
	^ self new left: left; right: aRight
	! !

!P4TACOperation methodsFor: 'visiting' stamp: 'ToonVerwaest 6/14/2011 15:08'!
acceptRegisterSwapper: aVisitor 
	^ aVisitor visitOperation: self  ! !

!P4TACOperation methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 14:46'!
left
	^ left! !

!P4TACOperation methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 14:47'!
left: aLeft
	left := aLeft.! !

!P4TACOperation methodsFor: 'printing' stamp: 'ToonVerwaest 6/14/2011 14:47'!
printOn: stream
	self printLineNumberOn: stream.
	stream << self op << ' '.  
	left printOn: stream.
	stream << ', '.
	right printOn: stream.
	stream << Character tab << Character tab << Character tab << Character tab.
	stream << '#'.
	left printRegisterOn: stream .
	stream  << ', '.
	right printRegisterOn: stream.
	stream << Character cr
! !

!P4TACOperation methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 14:46'!
right
	^ right! !

!P4TACOperation methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 14:46'!
right: aValue
	"self assert: ( aValue respondsTo: #asRegister )."
	right := aValue.! !

P4TACOperation subclass: #P4TACOr
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACOr methodsFor: 'visitor accepting' stamp: 'ToonVerwaest 6/14/2011 14:57'!
accept: aVisitor
	^ aVisitor visitOr: self! !

!P4TACOr methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 17:35'!
op
	^ #or! !

P4TACOperation subclass: #P4TACSub
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACSub methodsFor: 'visitor accepting' stamp: 'ToonVerwaest 6/14/2011 14:57'!
accept: aVisitor
	^ aVisitor visitSub: self! !

!P4TACSub methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 17:35'!
op
	^ #sub! !

P4TACOperation subclass: #P4TACTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACTest methodsFor: 'visitor accepting' stamp: 'ToonVerwaest 6/14/2011 17:35'!
accept: aVisitor
	^ aVisitor visitTest: self! !

!P4TACTest methodsFor: 'accessing' stamp: 'ToonVerwaest 6/14/2011 17:35'!
op
	^ #test! !

P4TACOperation subclass: #P4TACXOr
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACXOr methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/11/2011 18:56'!
accept: aVisitor
	^ aVisitor visitXor: self! !

!P4TACXOr methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/11/2011 18:56'!
op
	^ #xor! !

P4TACInstruction subclass: #P4TACPop
	instanceVariableNames: 'register'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

P4TACPop class
	instanceVariableNames: 'register'!

P4TACPop class
	instanceVariableNames: 'register'!

!P4TACPop class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/3/2012 15:38'!
register: aRegister
	^ self new
		register: aRegister.! !

!P4TACPop methodsFor: 'visitor accepting' stamp: 'ToonVerwaest 5/13/2011 16:16'!
accept: aVisitor
	^ aVisitor visitPop: self! !

!P4TACPop methodsFor: 'printing' stamp: 'OliFlueckiger 5/13/2011 15:57'!
printOn: aStream
	aStream << 'pop ' << register asString << Character cr.! !

!P4TACPop methodsFor: 'accessing' stamp: 'OliFlueckiger 5/13/2011 15:50'!
register
	^ register! !

!P4TACPop methodsFor: 'accessing' stamp: 'OliFlueckiger 5/13/2011 15:50'!
register: anObject
	register := anObject! !

P4TACInstruction subclass: #P4TACPush
	instanceVariableNames: 'variable register'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

P4TACPush class
	instanceVariableNames: 'register'!

P4TACPush class
	instanceVariableNames: 'register'!

!P4TACPush class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/3/2012 15:38'!
register: aRegister
	^ self new
		register: aRegister.! !

!P4TACPush methodsFor: 'visiting' stamp: 'ToonVerwaest 5/13/2011 16:16'!
accept: aVisitor
	^ aVisitor visitPush: self! !

!P4TACPush methodsFor: 'printing' stamp: 'OliFlueckiger 5/13/2011 15:57'!
printOn: aStream
	aStream << 'push ' << register asString << Character cr.! !

!P4TACPush methodsFor: 'accessing' stamp: 'OliFlueckiger 8/4/2011 12:12'!
register
	register ifNotNil: [ ^ register ].
	^ variable register! !

!P4TACPush methodsFor: 'accessing' stamp: 'OliFlueckiger 8/4/2011 12:12'!
register: aRegister
	register := aRegister ! !

!P4TACPush methodsFor: 'accessing' stamp: 'OliFlueckiger 8/4/2011 12:08'!
variable: anObject
	variable := anObject! !

P4TACInstruction subclass: #P4TACReturn
	instanceVariableNames: 'teardown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACReturn methodsFor: 'visiting' stamp: 'ToonVerwaest 5/6/2011 19:51'!
accept: aVisitor
	^ aVisitor visitReturn: self! !

!P4TACReturn methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/12/2011 16:20'!
initialize 
	teardown := true! !

!P4TACReturn methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/12/2011 15:58'!
noTeardown
	teardown := false! !

!P4TACReturn methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/7/2011 12:21'!
printOn: stream
	self printLineNumberOn: stream.  
	stream << 'return' << Character cr! !

!P4TACReturn methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/12/2011 16:20'!
tearDown 
	^teardown! !

P4TACInstruction subclass: #P4TACTeardown
	instanceVariableNames: 'teardown keepArguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACTeardown methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/12/2011 15:59'!
accept: aVisitor
	^ aVisitor visitTeardown: self! !

!P4TACTeardown methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 9/7/2011 14:34'!
initialize 
	super initialize .
	keepArguments := false! !

!P4TACTeardown methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 9/7/2011 14:33'!
keepArguments 
	keepArguments := true! !

!P4TACTeardown methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/12/2011 15:59'!
printOn: stream
	self printLineNumberOn: stream.  
	stream << '--teardown Frame' << Character cr! !

!P4TACTeardown methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 9/7/2011 14:33'!
shouldKeepArguments
	^ keepArguments! !

P4TACInstruction subclass: #P4TACVolatileFence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-IR'!

!P4TACVolatileFence methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 6/14/2012 17:35'!
accept: visitor
	^ visitor visitVolatileFence: self! !

!P4TACVolatileFence methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/10/2011 14:31'!
printOn: stream
	stream << '--volatile fence--' << Character cr! !

P4Object subclass: #P4TACInlineMessages
	instanceVariableNames: 'visitor builder receiver helper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

!P4TACInlineMessages class methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/6/2011 15:29'!
doesNotUnderstand
	^ nil! !

!P4TACInlineMessages class methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/6/2011 15:09'!
instance
	instance isNil ifTrue: [ instance := self new ].
	^ instance! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 8/30/2011 12:36'!
+ other
	| res msg aReceiver blockTmp anOther |
	aReceiver := builder temporaryStore: (receiver accept: visitor).
	anOther := other accept: visitor.
	res := builder nextTemp.
	aReceiver 
		wrapTypeGuard: {P4SmallInteger asPClass}
		andCondition: {#carry}
		around: [ 
			builder move: aReceiver to: res.
			builder intAdd: anOther to: res.]
		fallback: [ 
			msg := P4TACMessage new selector: #+ ; numOfArguments: 1.
			visitor tacSend: msg to: aReceiver with: {anOther}.
			builder move: helper resultVariable to: res. ]
		with: helper.
	^ res! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 8/30/2011 12:36'!
- other
	| res msg aReceiver blockTmp anOther |
	aReceiver := builder temporaryStore: (receiver accept: visitor).
	anOther := other accept: visitor.
	res := builder nextTemp.
	aReceiver 
		wrapTypeGuard: {P4SmallInteger asPClass}
		andCondition: {#carry}
		around: [ 
			builder move: aReceiver to: res.
			builder intSub: anOther from: res.]
		fallback: [ 
			msg := P4TACMessage new selector: #- ; numOfArguments: 1.
			visitor tacSend: msg to: aReceiver with: {anOther}.
			builder move: helper resultVariable to: res. ]
		with: helper.
	^ res! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'ToonVerwaest 8/5/2011 12:35'!
== other
	| nextBlock resultValue left right temp trueBlock |

	left := receiver accept: visitor.
	right := other accept: visitor.
	temp := builder nextTemp.
	builder move: right to: temp.
	
	trueBlock := builder nextBasicBlock.
	nextBlock := builder nextBasicBlock.
	resultValue := builder nextTemp.
	
	builder compare: left to: temp.
	builder jumpEqual: trueBlock.
	builder move: builder false to: resultValue.
	builder jump: nextBlock.
		
	builder useAsNextBasicBlock: trueBlock.  
	builder move: builder true to: resultValue.

	builder useAsNextBasicBlock: nextBlock.	
	^ resultValue ! !

!P4TACInlineMessages methodsFor: 'convenience' stamp: 'OliFlueckiger 8/29/2011 14:52'!
block: block condition: aCondition receiver: aReceiver equal: testEquals result: resultValue
	| nextBlock |

	builder move: builder nil to: resultValue.

	builder compare: aCondition to: aReceiver.
		
	nextBlock := builder nextBasicBlock.
	testEquals 
		ifTrue: [ builder jumpNotEqual: nextBlock. ]
		ifFalse: [ builder jumpEqual: nextBlock. ].

	visitor visitInlinedBlock: block returnTo: resultValue.
	
	builder useAsNextBasicBlock: nextBlock.! !

!P4TACInlineMessages methodsFor: 'convenience' stamp: 'OliFlueckiger 8/29/2011 14:52'!
block: block condition: aCondition receiver: aReceiver result: resultValue
	^self block: block condition: aCondition receiver: aReceiver equal: true result: resultValue! !

!P4TACInlineMessages methodsFor: 'accessing' stamp: 'OliFlueckiger 5/7/2011 14:47'!
builder: aBuilder
	builder := aBuilder .! !

!P4TACInlineMessages methodsFor: 'convenience' stamp: 'ToonVerwaest 8/5/2011 12:38'!
checkReturns: aBasicBlock to: aVariable
	aBasicBlock isEmpty 
		ifTrue: [ builder move: builder nil to: aVariable ]
		ifFalse: [ builder move: aBasicBlock lastElement asValue to: aVariable ].
! !

!P4TACInlineMessages methodsFor: 'accessing' stamp: 'OliFlueckiger 8/24/2011 10:43'!
helper: aHelper
	helper := aHelper ! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 8/30/2011 12:26'!
ifFalse: block
	| aReceiver nextBlock fallbackBlock resultValue testBlock msg aBlock |
	aReceiver := builder temporaryStore: (receiver accept: visitor).
	resultValue := builder nextTemp.
	builder move: builder nil to: resultValue.
	
	nextBlock := builder nextBasicBlock.
	testBlock := builder nextBasicBlock.
	fallbackBlock := builder nextBasicBlock.

	builder compare: builder false to: aReceiver.
	builder jumpNotEqual: testBlock.

	visitor visitInlinedBlock: block returnTo: resultValue.
	builder shortJump: nextBlock.
	
	builder useAsNextBasicBlock: testBlock.    
	builder compare: builder true to: aReceiver.   
	builder shortJumpNotEqual: fallbackBlock.
	builder shortJump: nextBlock.
	  
	builder useAsNextBasicBlock: fallbackBlock.    
	msg := P4TACMessage new selector: #ifFalse: ; numOfArguments: 1.
	aBlock := block accept: visitor.
	visitor tacSend: msg to: aReceiver with: { aBlock }.
	builder move: helper resultVariable to: resultValue.
	
	builder useAsNextBasicBlock: nextBlock.
	
	^ resultValue! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 8/30/2011 12:41'!
ifFalse: falseBlock ifTrue: trueBlock
	| trueBasicBlock nextBasicBlock result value fallbackBasicBlock msg trueArg falseArg |
	value := builder temporaryStore: (receiver accept: visitor).
	
	trueBasicBlock := builder nextBasicBlock.  
	fallbackBasicBlock := builder nextBasicBlock.
	nextBasicBlock := builder nextBasicBlock.

	result := builder nextTemp .
	
	builder compare: builder true to: value.
	builder jumpEqual: trueBasicBlock.
	builder compare: builder false to: value.
	builder jumpNotEqual: fallbackBasicBlock.
	
	visitor visitInlinedBlock: falseBlock returnTo: result .
	builder jump: nextBasicBlock.
		
	builder useAsNextBasicBlock: trueBasicBlock.
	visitor visitInlinedBlock: trueBlock returnTo: result.
	builder jump: nextBasicBlock.
	
	builder useAsNextBasicBlock: fallbackBasicBlock.
	msg := P4TACMessage new selector: #ifFalse:ifTrue: ; numOfArguments: 2.
	falseArg := builder temporaryStore: (falseBlock accept: visitor).
	trueArg := trueBlock accept: visitor.
	visitor tacSend: msg to: value with: { falseArg. trueArg }.
	builder move: helper resultVariable to: result.

	builder useAsNextBasicBlock: nextBasicBlock.
	^ result ! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 8/29/2011 23:18'!
ifNil: block
	| aReceiver res |
	aReceiver := receiver accept: visitor.
	res := builder nextTemp.
	self block: block condition: builder nil receiver: aReceiver result: res.
	^ res.! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'CamilloBruni 12/15/2011 23:58'!
ifNil: block ifNotNil: notblock
	| receiverTemp evaluatedReceiverTemp notNilBlock nilBlock nextBlock ret |
	notblock arguments 
		ifNotEmpty: [
			receiverTemp := builder declare: notblock arguments first name.
			evaluatedReceiverTemp := receiver accept: visitor.
			builder move: evaluatedReceiverTemp to: receiverTemp]
		ifEmpty: [
			receiverTemp := receiver accept: visitor].
		
	notNilBlock := builder nextBasicBlock.
	nilBlock := builder nextBasicBlock.
	nextBlock := builder nextBasicBlock.
	ret := builder nextTemp.
	builder move: builder nil to: ret.
		
	builder compare: builder nil to: receiverTemp.
	builder jumpEqual: nilBlock.
	
	builder useAsNextBasicBlock: notNilBlock.
	visitor visitInlinedBlock: notblock returnTo: ret.
	builder jump: nextBlock.
	
	builder useAsNextBasicBlock: nilBlock.
	visitor visitInlinedBlock: block returnTo: ret.
	
	builder useAsNextBasicBlock: nextBlock.  
	^ ret! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'CamilloBruni 12/15/2011 23:43'!
ifNotNil: block
	| receiverTemp evaluatedReceiverTemp res |
	evaluatedReceiverTemp := receiver accept: visitor.
	block arguments ifNotEmpty: [
		receiverTemp := builder declare: block arguments first name.
		builder move: evaluatedReceiverTemp to: receiverTemp ] .
	res := builder nextTemp.
	self block: block condition: builder nil receiver: evaluatedReceiverTemp equal: false result: res.
	^ res! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 8/11/2011 18:11'!
ifNotNil: notblock ifNil: block
	^ self ifNil: block ifNotNil: notblock
	
! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 8/30/2011 12:26'!
ifTrue: block
	| aReceiver nextBlock fallbackBlock resultValue testBlock msg aBlock |
	aReceiver := builder temporaryStore: (receiver accept: visitor).
	resultValue := builder nextTemp.
	builder move: builder nil to: resultValue.
	
	nextBlock := builder nextBasicBlock.
	testBlock := builder nextBasicBlock.
	fallbackBlock := builder nextBasicBlock.

	builder compare: builder true to: aReceiver.
	builder jumpNotEqual: testBlock.

	visitor visitInlinedBlock: block returnTo: resultValue.
	builder shortJump: nextBlock.
	
	builder useAsNextBasicBlock: testBlock.    
	builder compare: builder false to: aReceiver.   
	builder shortJumpNotEqual: fallbackBlock.
	builder shortJump: nextBlock.
	  
	builder useAsNextBasicBlock: fallbackBlock.
	msg := P4TACMessage new selector: #ifTrue: ; numOfArguments: 1.
	aBlock := block accept: visitor.
	visitor tacSend: msg to: aReceiver with: { aBlock }.
	builder move: helper resultVariable to: resultValue.
	
	builder useAsNextBasicBlock: nextBlock.
	
	^ resultValue! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 8/31/2011 17:31'!
ifTrue: trueBlock ifFalse: falseBlock
	| falseBasicBlock nextBasicBlock result value fallbackBasicBlock msg trueArg falseArg |
	value := builder temporaryStore: (receiver accept: visitor).
	
	falseBasicBlock := builder nextBasicBlock.  
	fallbackBasicBlock := builder nextBasicBlock.
	nextBasicBlock := builder nextBasicBlock.

	result := builder nextTemp .
	
	builder compare: builder false to: value.
	builder jumpEqual: falseBasicBlock.
	builder compare: builder true to: value.
	builder jumpNotEqual: fallbackBasicBlock.
	
	visitor visitInlinedBlock: trueBlock returnTo: result .
	builder jump: nextBasicBlock.
		
	builder useAsNextBasicBlock: falseBasicBlock.
	visitor visitInlinedBlock: falseBlock returnTo: result.
	builder jump: nextBasicBlock.
	
	builder useAsNextBasicBlock: fallbackBasicBlock.
	msg := P4TACMessage new selector: #ifTrue:ifFalse: ; numOfArguments: 2.
	trueArg := builder temporaryStore: (trueBlock accept: visitor).
	falseArg := falseBlock accept: visitor.
	visitor tacSend: msg to: value with: { trueArg. falseArg }.
	builder move: helper resultVariable to: result.

	builder useAsNextBasicBlock: nextBasicBlock .  	
	^ result ! !

!P4TACInlineMessages methodsFor: 'accessing' stamp: 'OliFlueckiger 5/26/2011 11:19'!
implements: aSelector
	| method |
	method := self class methodDictionary at: aSelector ifAbsent: [ ^ false ].
	^ method category == #'control-messages'
! !

!P4TACInlineMessages methodsFor: 'convenience' stamp: 'OliFlueckiger 9/8/2011 16:10'!
methodObject: aMethod perform: selector
	| msg aSelector numArgs |

	numArgs := builder nextTemp.
	aSelector := selector accept: visitor.
	msg := P4TACMessage new selector: #countArgs; numOfArguments: 0.
	visitor tacSend: msg to: aSelector with: {}.
	builder move: helper resultVariable to: numArgs.
	
	msg := P4TACMessage new selector: #basicNew:; numOfArguments: 1.
	visitor tacSend: msg to: (builder loadConstant: Array asPClass) with: { numArgs }.
	
	builder move: helper resultVariable to: (helper arg:4 of:4).
	builder move: aSelector to: (helper arg:2 of:4).
	builder move: aMethod to: (helper arg:1 of:4).
	builder move: (builder loadConstant: #perform:on:with:) to: helper resultVariable.
	builder move: numArgs to: helper intermediateLValue.
	
	builder teardownToPerform.
	builder move: (helper stackPointer accessAt: 0) to: (helper arg:3 of:4).
	builder jump: #'wrap_and_call'! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 7/25/2011 11:54'!
pHalt
	^ builder pHalt! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 12/7/2011 22:18'!
perform: selector andCacheOn: object  
	| aMethod anObject msg |
	aMethod := builder temporaryStore: (receiver accept: visitor).
	anObject := object accept: visitor.
	aMethod 
		wrapTypeGuard: {P4Method asPClass}
		around: [
			builder move: (aMethod accessAt: 0) to: helper intermediateLValue.
			builder untag: helper intermediateLValue.
			builder bitShift: helper intermediateLValue by: 3.
			builder add: aMethod to: helper intermediateLValue.
			builder move: anObject to: (helper arg: 1 of: 1).
			builder directCallSkipTypeCheck: (P4Object earlySelectorAddress: #behavior) on: P4Object asPClass.
			builder 	tailJump: 'inline_cache_and_call' asSymbol .]
		fallback: [
			self methodObject: aMethod perform: selector ]
		with: helper.
	^ aMethod! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 12/7/2011 22:18'!
perform: selector on: object  
	| aMethod anObject |
	aMethod := builder temporaryStore: (receiver accept: visitor).
	anObject := object accept: visitor.
	aMethod 
		wrapTypeGuard: {P4Method asPClass}
		around: [
			builder move: (aMethod accessAt: 0) to: helper intermediateLValue.
			builder untag: helper intermediateLValue.
			builder bitShift: helper intermediateLValue by: 3.
			builder add: aMethod to: helper intermediateLValue.
			builder move: anObject to: (helper arg: 1 of: 1).
			builder directCallSkipTypeCheck: (P4Object earlySelectorAddress: #behavior) on: P4Object asPClass.
			builder 	indirectTailJump: helper intermediateLValue.]
		fallback: [
			self methodObject: aMethod perform: selector ]
		with: helper.
	^ aMethod! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 12/7/2011 19:01'!
perform: selector on: object with: arguments
	| aMethod anObject theArgs aSelector msg |
	aMethod := builder temporaryStore: (receiver accept: visitor).
	aSelector := builder temporaryStore: (selector accept: visitor).
	anObject := builder temporaryStore: (object accept: visitor).
	theArgs := arguments accept: visitor.  
	aMethod 
		wrapTypeGuard: {P4Method asPClass}
		around: [
			builder move: (aMethod accessAt: 0) to: helper intermediateLValue.
			builder untag: helper intermediateLValue.
			builder bitShift: helper intermediateLValue by: 3.
			builder add: aMethod to: helper intermediateLValue.
			builder move: anObject to: (helper arg: 1 of: 1).
			builder directCallSkipTypeCheck: (P4Object earlySelectorAddress: #behavior) on: P4Object asPClass.
			builder move: theArgs to: (helper intermediate).
			builder directCall: #'unwrap'.
			builder 	indirectTailJump: helper intermediateLValue.]
		fallback: [
			msg := P4TACMessage new selector: #perform:on:with:; numOfArguments: 3.
			visitor tacSend: msg to: aMethod with: { aSelector. anObject. theArgs }. ]
		with: helper.
	^ aMethod! !

!P4TACInlineMessages methodsFor: 'facade' stamp: 'CamilloBruni 12/14/2011 17:04'!
send: aMessage to: aReceiver with: theArguments for: aVisitor
	receiver := aReceiver.
	visitor := aVisitor.
	^ self perform: aMessage selector withArguments: theArguments asArray.
! !

!P4TACInlineMessages methodsFor: 'convenience' stamp: 'OliFlueckiger 8/31/2011 16:56'!
sendValue: msg to: aReceiver
	
	aReceiver 
		wrapTypeGuard: {P4Closure asPClass}
		around: [ 
			builder move: (aReceiver accessAt: 0) to: helper intermediate.
			builder indirectCall: helper intermediate]
		fallback: [ 
			helper invoke: msg for: aReceiver with: {}]
		with: helper.
		
	^ helper resultVariable.! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'CamilloBruni 12/15/2011 14:14'!
to: end by: step do: aBlock
	| startValue endValue stepValue resultValue currentValue bodyBlock nextBlock res plus smaller msg currentValueName |
	startValue := builder temporaryStore: (receiver accept: visitor).
	endValue := builder temporaryStore: (end accept: visitor).
	stepValue := builder temporaryStore: (step accept: visitor).
	
	plus := P4TACMessage new selector: #+ ; numOfArguments: 1.
	smaller := P4TACMessage new selector: #<= ; numOfArguments: 1.
	resultValue := builder nextTemp.
	
	startValue
		wrapTypeGuard: {P4SmallInteger asPClass } 
		around: [
			builder move: builder nil to: resultValue.
			currentValueName := aBlock arguments ifEmpty: [ #index ] ifNotEmpty: [ aBlock arguments first name ].
			currentValue := builder declare: currentValueName.
			builder move: startValue to: currentValue.
	
			bodyBlock := builder nextBasicBlock.
			nextBlock := builder nextBasicBlock.

			builder useAsNextBasicBlock: bodyBlock.
			res := visitor tacSend: smaller to: currentValue with: {endValue}.
			builder compare: builder true to: res.
			builder jumpNotEqual: nextBlock.  
		
			visitor visitInlinedBlock: aBlock returnTo: resultValue.
			res := visitor tacSend: plus to: currentValue with: {stepValue}.
			builder move: res to: currentValue.
			builder jump: bodyBlock.
	
			builder useAsNextBasicBlock: nextBlock.]
		fallback: [
			msg := P4TACMessage new selector: #to:by:do: ; numOfArguments: 3.
			visitor tacSend: msg to: startValue with: {stepValue . endValue }.
			builder move: helper resultVariable to: resultValue.]
		with: helper.
	^ resultValue! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 8/31/2011 16:56'!
value
	| msg aReceiver |
	aReceiver := receiver accept: visitor.
	builder volatileFence.
	
	msg := P4TACMessage new selector: #value; numOfArguments: 0.
	helper loadArguments: {} andReceiver: aReceiver toSend: msg selector.
	
	^ self sendValue: msg to: aReceiver! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 8/31/2011 17:16'!
value: arg
	| msg aReceiver anArg |
	aReceiver := builder temporaryStore: (receiver accept: visitor).
	anArg := arg accept: visitor.  
	builder volatileFence.
	
	msg := P4TACMessage new selector: #value:; numOfArguments: 1.
	helper loadArguments: {anArg} andReceiver: aReceiver toSend: msg selector.

	^ self sendValue: msg to: aReceiver! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 8/31/2011 17:16'!
value: arg1 value: arg2
	| msg aReceiver anArg1 anArg2 |
	aReceiver := builder temporaryStore: (receiver accept: visitor).
	anArg1 := builder temporaryStore: (arg1 accept: visitor).
	anArg2 := arg2 accept: visitor.  
	builder volatileFence.
	
	msg := P4TACMessage new selector: #value:value:; numOfArguments: 2.
	helper loadArguments: {anArg1. anArg2} andReceiver: aReceiver toSend: msg selector.

	^ self sendValue: msg to: aReceiver! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 8/31/2011 17:17'!
value: arg1 value: arg2 value: arg3
	| msg aReceiver anArg1 anArg2 anArg3 |
	aReceiver := builder temporaryStore: (receiver accept: visitor).
	anArg1 := builder temporaryStore: (arg1 accept: visitor).
	anArg2 := builder temporaryStore: (arg2 accept: visitor).
	anArg3 := arg3 accept: visitor.  
	builder volatileFence.
	
	msg := P4TACMessage new selector: #value:value:value:; numOfArguments: 3.
	helper loadArguments: {anArg1. anArg2. anArg3} andReceiver: aReceiver toSend: msg selector.

	^ self sendValue: msg to: aReceiver! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'OliFlueckiger 8/31/2011 17:17'!
value: arg1 value: arg2 value: arg3 value: arg4
	| msg aReceiver anArg1 anArg2 anArg3 anArg4 |
	aReceiver := builder temporaryStore: (receiver accept: visitor).
	anArg1 := builder temporaryStore: (arg1 accept: visitor).
	anArg2 := builder temporaryStore: (arg2 accept: visitor).
	anArg3 := builder temporaryStore: (arg3 accept: visitor).
	anArg4 := arg4 accept: visitor.  
	builder volatileFence.
	
	msg := P4TACMessage new selector: #value:value:value:value:; numOfArguments: 4.
	helper loadArguments: {anArg1. anArg2. anArg3. anArg4} andReceiver: aReceiver toSend: msg selector.

	^ self sendValue: msg to: aReceiver! !

!P4TACInlineMessages methodsFor: 'accessing' stamp: 'OliFlueckiger 5/6/2011 18:21'!
visitor
	^ visitor! !

!P4TACInlineMessages methodsFor: 'accessing' stamp: 'ToonVerwaest 5/25/2011 15:17'!
visitor: anObject
	visitor := anObject.! !

!P4TACInlineMessages methodsFor: 'convenience' stamp: 'ToonVerwaest 8/5/2011 12:37'!
while: block condition: aCondition
	| whileBasicBlock nextBasicBlock checkResult result checkBlock |
	checkBlock := receiver.	
	whileBasicBlock := builder nextBasicBlock.  
	nextBasicBlock := builder nextBasicBlock.	
	builder useAsNextBasicBlock: whileBasicBlock.  

	checkResult := builder nextTemp.
	visitor visitInlinedBlock: checkBlock returnTo: checkResult.
	builder compare: aCondition to: checkResult.
	builder jumpNotEqual: nextBasicBlock.
	
	result := builder nextTemp.
	visitor visitInlinedBlock: block returnTo: result.
	builder jump: whileBasicBlock.  

	builder useAsNextBasicBlock: nextBasicBlock.
	^ result! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'ToonVerwaest 8/5/2011 12:38'!
whileFalse: block
	^ self while: block condition: builder false! !

!P4TACInlineMessages methodsFor: 'control-messages' stamp: 'ToonVerwaest 8/5/2011 12:38'!
whileTrue: block
	^ self while: block condition: builder true! !

P4Object subclass: #P4TACLinearScanRegisterAllocator
	instanceVariableNames: 'usedRegisters maxUsedRegisters stackSize variables actives usedVolatileRegisters asm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2012 13:41'!
asm: anAssembler
	asm := anAssembler! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/12/2011 18:50'!
assignRegister: aRegister to: aVariable
	aVariable register: aRegister! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/3/2012 15:19'!
backupRegistersFor: aMethod
	| block |
	block := aMethod registerPushing.
	block positionAtBeginning.
	aMethod hasNonLocalReturn ifTrue: [ maxUsedRegisters := self numberOfRegisters ].
	
	1 to: maxUsedRegisters do: [ :i |
		block << (asm extraRegisters at: i) push ].
	
	aMethod hasNonLocalReturn 
		ifTrue: [ block << (asm intermediateRegisters at: 1) push ].
	
	block := aMethod postamble.
	block positionAtBeginning.
	aMethod hasNonLocalReturn 
		ifTrue: [ block << (asm intermediateRegisters at: 1) pop ].
		
	maxUsedRegisters to: 1 by: -1 do: [ :i |
		block << (asm extraRegisters at: i) pop ].

! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/11/2011 11:38'!
checkForUnassignedLocals: locals
	locals do: [ :l |
		l firstAssign ifNil: [
			self error: 'Register allocation cannot proceed. there seems to be a problem with the TAC since a variable was used but never assigned.']]! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/9/2011 21:08'!
expireIntervalsBefore: line
	| toRemove |
	toRemove := 0.
	actives reverseDo: [ :var |
		( var lastUse > line ) 
			ifTrue: [ ^ actives removeLast: toRemove ].
		toRemove := toRemove + 1.
		self freeRegister: var register.
	].

	^ actives removeFirst: toRemove! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/3/2012 15:19'!
freeRegister: aRegister
	(usedVolatileRegisters includes: aRegister) 
		ifTrue: [ ^ usedVolatileRegisters remove: aRegister ].
	
	(usedRegisters includes: aRegister) 
		ifTrue: [ ^ usedRegisters remove: aRegister ].
	
	self error: 'cannot free unused register ', aRegister asString.
! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/10/2011 14:06'!
isRegisterFreeFor: variable
	variable canBeVolatile ifTrue: [
		(usedVolatileRegisters size < self numberOfVolatileRegisters)
			ifTrue: [ ^ true ]].
	^ usedRegisters size < self numberOfRegisters
! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/12/2011 17:37'!
linearScanRegisterAllocation
	variables do: [ :var |
		self expireIntervalsBefore: var firstAssign.
		(self isRegisterFreeFor: var)
			ifFalse: [ self spill: var ]
			ifTrue: [
				self nextFreeRegisterFor: var.  
				actives add: var ]].! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/10/2011 14:02'!
nextFreeRegisterFor: aVariable
	aVariable canBeVolatile ifTrue: [ (self nextVolatileRegisterFor: aVariable) ifNotNil: [ ^self ]].
	(self nextRegisterFor: aVariable) ifNil: [ self error: 'couldn''t find a free register' ]! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2012 13:41'!
nextRegisterFor: aVariable
	asm extraRegisters do: [ :r |
		(usedRegisters includes: r) ifFalse: [
			( maxUsedRegisters == usedRegisters size ) ifTrue: [
				maxUsedRegisters := maxUsedRegisters +1].
			usedRegisters add: r.
			^ aVariable assignRegister: r for: self ]].
	^ nil! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2012 13:41'!
nextStackPosition
	| oldSize |
	oldSize := stackSize.
	stackSize := stackSize + 1.
	^ P4ASMRegisterAccess new
		register: asm stackPointer;
		offset: oldSize * asm pointerSize! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2012 13:41'!
nextVolatileRegisterFor: aVariable
	asm volatileRegisters do: [ :r |
		(usedVolatileRegisters includes: r) ifFalse: [
			usedVolatileRegisters add: r.
			^ aVariable assignRegister: r for: self ]].
	^ nil.! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2012 13:41'!
numberOfRegisters
	^ asm extraRegisters size! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/29/2012 13:41'!
numberOfVolatileRegisters
	^ asm volatileRegisters size! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 5/28/2011 18:54'!
runOn: aTACNode
	aTACNode accept: self
	! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/29/2011 14:40'!
spill: variable
	| spill |
	"self has to stay in a register. otherwise getting the class of an instVar can be a triple access."
	spill := actives first.
	spill isSelf ifTrue: [ spill := actives second ].  
	( spill lastUse > variable lastUse or: [variable isSelf])
		ifTrue: [
			variable register: spill register .  
			spill register: self nextStackPosition.
			actives remove: spill.
			actives add: variable.
		] ifFalse: [
			variable register: self nextStackPosition.
		]! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/3/2012 15:12'!
visitCallable: aCallable
	aCallable expungeUnusedLocals.
	
	self checkForUnassignedLocals: aCallable locals values.  
	self checkForUnassignedLocals: aCallable temps.  
	
	variables := aCallable locals values asSortedCollection:  [ :a :b | a firstAssign < b firstAssign ].
	variables addAll: aCallable temps.
	
	actives := SortedCollection sortBlock: [ :a :b | a lastUse > b lastUse ].
	usedRegisters := Set new.
	usedVolatileRegisters := Set new.
	stackSize := 0.
	maxUsedRegisters := 0.
	
	self linearScanRegisterAllocation.
	aCallable usedRegisters: maxUsedRegisters .
	aCallable frameSize: stackSize.
	self backupRegistersFor: aCallable.! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/26/2011 17:58'!
visitClosure: aClosure
	self visitCallable: aClosure   ! !

!P4TACLinearScanRegisterAllocator methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/26/2011 18:05'!
visitMethod: aMethod
	self visitCallable: aMethod.
	
	aMethod closures do: [ :closure |
		closure accept: self ]
! !

P4Object subclass: #P4TACLivenessAnalysis
	instanceVariableNames: 'position callable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

!P4TACLivenessAnalysis methodsFor: 'private' stamp: 'OliFlueckiger 7/25/2011 14:38'!
removeInstructionsOf: aMethod
	| toRemove currentBasicBlock |
	currentBasicBlock := aMethod preamble.
	[ currentBasicBlock atEnd ] whileFalse: [
		currentBasicBlock do: [ :instruction |
			instruction isAssignment ifTrue: [
				(instruction target isUnused) ifTrue: [
					currentBasicBlock remove: instruction ]]].
		currentBasicBlock := currentBasicBlock nextBlock. ].
! !

!P4TACLivenessAnalysis methodsFor: 'accessing' stamp: 'OliFlueckiger 5/6/2011 22:19'!
runOn: aTACNode
	aTACNode accept: self
	! !

!P4TACLivenessAnalysis methodsFor: 'exceptionbuilder' stamp: 'ToonVerwaest 5/24/2011 18:07'!
tag: aTAC
	position := position +1.
	aTAC flowNumber: position .  
	  ! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'ToonVerwaest 6/14/2011 15:10'!
visitAdd: anAdd
	self visitOperation: anAdd! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'ToonVerwaest 6/14/2011 15:37'!
visitAnd: anAnd
	self visitOperation: anAnd! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 6/9/2011 18:21'!
visitAssignment: anAssignment
	self tag: anAssignment .
	anAssignment target assignedAt: position.
	anAssignment origin usedAt: position.  
	  ! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 6/8/2011 16:11'!
visitBasicBlock: aBasicBlock
	aBasicBlock do: [ :s | s accept: self ]. 	! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 9/6/2011 16:53'!
visitBitShift: aBitShift
	self tag: aBitShift.
	aBitShift target usedAt: position.
! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 9/6/2011 16:53'!
visitBitShiftRight: aBitShift
	self tag: aBitShift.
	aBitShift target usedAt: position.
! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 6/17/2011 16:24'!
visitBitTest: aBitTest
	self tag: aBitTest.
	aBitTest location usedAt: position.
! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 6/10/2011 14:27'!
visitCall: aCall
	self tag: aCall.
! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 8/4/2011 15:50'!
visitCallable: aCallable
	position := 0.
	callable := aCallable.
	callable basicBlocksDo: [ :b | b accept: self ] .
	self removeInstructionsOf: aCallable.
! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'CamilloBruni 12/14/2011 17:09'!
visitCaptureClosure: capture
	self tag: capture.
	capture resultVariable assignedAt: position.  
	capture closure imports do: [ :aVariable | 
		aVariable usedAt: position+1 ].
	capture containsReturn ifTrue: [
		callable basePointer usedAt: position+1 ]  
! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 5/26/2011 17:57'!
visitClosure: aClosure
	self visitCallable: aClosure! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'ToonVerwaest 6/14/2011 15:09'!
visitCompare: aComparison
	self visitOperation: aComparison! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 5/7/2011 01:49'!
visitCompareEqual: aComparison
	self visitCompare: aComparison   	
	  ! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 5/7/2011 01:49'!
visitCompareNotEqual: aComparison
	self visitCompare: aComparison   	
	  ! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 6/17/2011 16:24'!
visitConditionalJump: aJump
	self tag: aJump! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 5/7/2011 13:57'!
visitEndBlock: aEndBlock
! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 6/8/2011 17:12'!
visitHalt: aHalt
  	self tag: aHalt! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 8/31/2011 16:30'!
visitIndirectCall: aCall
	self tag: aCall.
! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'ToonVerwaest 5/27/2011 17:27'!
visitIndirectJump: anIndirectJump
	self tag: anIndirectJump.
	anIndirectJump register usedAt: position
	
! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 8/29/2011 20:23'!
visitJump: aJump
	| startPos |
	self tag: aJump.
	aJump target isSymbol ifTrue: [^self].
	startPos := aJump target firstElement flowNumber.
	"startPos was already tagged -> backJump"
	startPos ifNotNil: [
		{callable locals. callable temps} do: 
			[ :vars | vars do: [ :var |
				(var isUsed and: [var lastUse >= startPos]) ifTrue: [
					var usedAt: position ]]]].
! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 8/4/2011 16:13'!
visitMethod: aMethod
	self visitCallable: aMethod.
	
	aMethod closures do: [ :closure |
		closure accept: self ]
! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'ToonVerwaest 6/14/2011 15:10'!
visitOperation: anOperation
	self tag: anOperation.
	anOperation left usedAt: position.
	anOperation right usedAt: position.! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'ToonVerwaest 6/14/2011 15:10'!
visitOr: anOr
	self visitOperation: anOr! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 6/22/2011 11:33'!
visitPop: aReg! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 6/22/2011 11:33'!
visitPush: aReg! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 8/12/2011 15:56'!
visitReturn: aReturn
	self tag: aReturn! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'ToonVerwaest 6/14/2011 15:10'!
visitSub: aSub
	self visitOperation: aSub! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 8/12/2011 16:18'!
visitTeardown: aReturn
	self tag: aReturn! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'ToonVerwaest 6/14/2011 17:37'!
visitTest: aTest
	self visitOperation: aTest! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 8/29/2011 20:24'!
visitVolatileFence: volatileFence
	self tag: volatileFence.
	callable temps do: [ :t | t methodCalled: position ].
	callable locals do: [ :v | v methodCalled: position ].
! !

!P4TACLivenessAnalysis methodsFor: 'visiting' stamp: 'OliFlueckiger 8/11/2011 18:59'!
visitXor: anOr
	self visitOperation: anOr! !

P4Object subclass: #P4TACMessage
	instanceVariableNames: 'selector numOfArguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACMessage class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/10/2012 18:57'!
fromRBMessage: message
	^ self new 
		selector: message selector; 
		numOfArguments: message arguments size;
		yourself! !

!P4TACMessage methodsFor: 'accessing' stamp: 'OliFlueckiger 8/11/2011 17:15'!
numOfArguments
	^ numOfArguments! !

!P4TACMessage methodsFor: 'accessing' stamp: 'OliFlueckiger 8/11/2011 17:15'!
numOfArguments: anObject
	numOfArguments := anObject! !

!P4TACMessage methodsFor: 'accessing' stamp: 'OliFlueckiger 8/11/2011 17:15'!
selector
	^ selector! !

!P4TACMessage methodsFor: 'accessing' stamp: 'OliFlueckiger 8/11/2011 17:15'!
selector: anObject
	selector := anObject! !

P4Object subclass: #P4TACPostCompiler
	instanceVariableNames: 'toReplace callable basicBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

P4TACPostCompiler subclass: #P4TACAnalyzeRemote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

!P4TACAnalyzeRemote methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/29/2011 19:51'!
externalizeVariables
	| locals remotes |
	remotes := P4TACRemoteArray new.
	locals := callable locals.
	locals do: [ :var | 
		var shouldBeRemote ifTrue: [
			var remote: (remotes add: var).
			var firstAssign isNil ifFalse: [
				remotes assignedAt: var firstAssign.].
			remotes usedAt: var lastUse ]].
	
	callable remoteVariables: remotes.
	
	remotes isEmpty ifFalse: [
		remotes do: [ :remote | locals removeKey: remote name ].
		locals at: remotes name put: remotes. ].! !

!P4TACAnalyzeRemote methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/31/2011 17:29'!
process: statement
	statement acceptCaptureClosure: self! !

!P4TACAnalyzeRemote methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/29/2011 19:56'!
visitCallable: aCallable
	" first find which variables should be remote "
	super visitCallable: aCallable.
	" then make them remote "
	self externalizeVariables.
    ! !

!P4TACAnalyzeRemote methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/11/2011 13:07'!
visitCaptureClosure: captureClosure
	(captureClosure closure imports select: 
		[ :variable |	variable shouldBeRemote not ])   
			do: [ :variable |
				(variable lastAssign > captureClosure flowNumber) ifTrue: [
					variable beRemote ]]! !

P4TACPostCompiler subclass: #P4TACAssignmentRemover
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

!P4TACAssignmentRemover methodsFor: 'visiting' stamp: 'OliFlueckiger 8/29/2011 13:43'!
visitBasicBlock: aBasicBlock
	aBasicBlock isEmpty ifTrue: [ ^ self ].
	
	aBasicBlock do: [ :instr |
		( instr isAssignment and: [ instr origin asAsm == instr target asAsm ] ) 
			ifTrue: [ aBasicBlock remove: instr ]].! !

P4TACPostCompiler subclass: #P4TACClosureInstaller
	instanceVariableNames: 'helper importedRemotes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

!P4TACClosureInstaller methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/29/2011 19:45'!
fix: imports
	imports reverseDo: [ :aVariable |
		aVariable shouldBeRemote
			ifTrue: [
				imports remove: aVariable.
				importedRemotes add: aVariable remoteVariable ]].
	importedRemotes do: [ :aRemote | imports add: aRemote ].
	importedRemotes removeAll.! !

!P4TACClosureInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 6/24/2011 19:38'!
helper: aHelper
	helper := aHelper! !

!P4TACClosureInstaller methodsFor: 'initialize-release' stamp: 'ToonVerwaest 5/28/2011 15:55'!
initialize
	importedRemotes := P4IdentitySet new.! !

!P4TACClosureInstaller methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 7/26/2011 19:10'!
installRemotes: method
	(method entry positionAtBeginning) 
		<< ((P4TACConstant with: method remoteVariables size asTaggedInteger ) moveTo: ( helper arg: 1 of: 1 ));
		<< (P4TACCall to: (P4RemoteArray earlyClassSelectorAddress: #pNew:));
		<< (helper resultVariable moveTo: method remoteVariables).
! !

!P4TACClosureInstaller methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/29/2011 17:26'!
loadClosureVariable: closure
	| closureObj i unwind |
	closureObj := helper intermediateLValue.
	closure entry positionAtBeginning.
	closure entry << ((helper arg: 1 of: closure) moveTo: closureObj).  
	i := 1.
	closure imports do: [ :var |
		closure entry << ((closureObj accessAt: i) moveTo: (closure locals at: var name)).
		i := i + 1 ].! !

!P4TACClosureInstaller methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/31/2011 17:29'!
process: statement
	statement acceptCaptureClosure: self! !

!P4TACClosureInstaller methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 9/7/2011 13:28'!
unroll: captureClosure
	| closure imports copyImports i closureVariable |
	closure := captureClosure closure.
	imports := closure imports.
	self fix: imports.
	closureVariable := captureClosure resultVariable.
	closureVariable assignedAt: captureClosure flowNumber.  

	basicBlock overridePosition: captureClosure.
	basicBlock 
		<< ((P4TACConstant with: (imports size + 1) asTaggedInteger) moveTo: (helper arg: 1 of: 1));
		<< (P4TACCall to: (P4Closure earlyClassSelectorAddress: #pNew:));
		<< (helper resultVariable moveTo: closureVariable );
		
		<< ((P4TACReference new target: closure) loadAddressIn: helper intermediateLValue );
		<< (helper intermediateLValue moveTo: (closureVariable accessAt: 0 )).
			
	i := 1.
	imports do: [ :aVariable |
		basicBlock << (aVariable moveTo: (closureVariable accessAt: i)).
		i := i + 1]
! !

!P4TACClosureInstaller methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/7/2011 21:45'!
visitCaptureClosure: captureClosure
	self unroll: captureClosure.
	self loadClosureVariable: captureClosure closure.! !

!P4TACClosureInstaller methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/8/2011 16:20'!
visitMethod: method
	super visitMethod: method.
	method remoteVariables isEmpty ifFalse: [
		self installRemotes: method  ].
	method expungeUnusedLocals. ! !

!P4TACPostCompiler methodsFor: 'accessing' stamp: 'OliFlueckiger 6/8/2011 16:28'!
basicBlock
	^ basicBlock! !

!P4TACPostCompiler methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 5/27/2011 17:13'!
callable 
	^ callable ! !

!P4TACPostCompiler methodsFor: 'accessing' stamp: 'ToonVerwaest 5/28/2011 18:25'!
helper: aHelper
	helper := aHelper! !

!P4TACPostCompiler methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/26/2011 17:13'!
process: statement
	self subclassResponsibility! !

!P4TACPostCompiler methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/26/2011 17:09'!
runOn: aTACNode
	aTACNode accept: self
	
	! !

!P4TACPostCompiler methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/8/2011 16:28'!
visitBasicBlock: aBasicBlock
	basicBlock := aBasicBlock.
	basicBlock do: [ :i | self process: i.	].! !

!P4TACPostCompiler methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 5/28/2011 14:12'!
visitCallable: aCallable
	callable := aCallable.
	callable basicBlocksDo: [ :b | b accept: self ]  ! !

!P4TACPostCompiler methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/26/2011 18:00'!
visitClosure: aClosure
	self visitCallable: aClosure     
! !

!P4TACPostCompiler methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/26/2011 17:09'!
visitEndBlock: aBasicBlock
	! !

!P4TACPostCompiler methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/8/2011 17:13'!
visitMethod: aMethod
	self visitCallable: aMethod.  
	aMethod closures do: [ :closure |
		self visitClosure: closure  ]! !

P4TACPostCompiler subclass: #P4TACRegisterSwapper
	instanceVariableNames: 'helper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

!P4TACRegisterSwapper methodsFor: 'as yet unclassified' stamp: 'ToonVerwaest 6/24/2011 19:38'!
helper: aHelper
	helper := aHelper! !

!P4TACRegisterSwapper methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/26/2011 17:13'!
process: statement
	statement acceptRegisterSwapper: self! !

!P4TACRegisterSwapper methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/29/2011 15:43'!
visitOperation: instruction
	| left replacement right |
	replacement := P4ObjectStream new.
	( instruction left isDoubleAccess )
		ifTrue: [
			left := (helper intermediate).
			replacement << (instruction left variable moveTo: left).
			left := left accessAt: instruction left index ]
		ifFalse: [ left := instruction left  ].
	
	( instruction right isDoubleAccess )
		ifTrue: [
			right := helper intermediateLValue.
			replacement << (instruction right variable moveTo: right).
			right := right accessAt: instruction right index ]
		ifFalse: [ right := instruction right ].
		
	( (left isAccess or: [ left isConstant]) and: [ right isAccess or: [ right isConstant ] ] ) ifTrue: [
		replacement << (left moveTo: helper intermediate).
		left := helper intermediate].
	
	replacement isEmpty ifFalse: [
		instruction left: left; right: right.
		replacement << instruction.
		(basicBlock overridePosition: instruction)  << replacement]! !

P4Object subclass: #P4TACValue
	instanceVariableNames: 'typeHint staticType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

P4TACValue subclass: #P4TACAbstractVariable
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACAbstractVariable class methodsFor: 'instance creation' stamp: 'OliFlueckiger 8/4/2011 16:24'!
named: aName
self haltIf: aName == #closure.
	^ (self new) name: aName ! !

!P4TACAbstractVariable methodsFor: 'visiting' stamp: 'OliFlueckiger 6/9/2011 16:53'!
accept: aVisitor
	^ aVisitor visitVariable: self! !

!P4TACAbstractVariable methodsFor: 'conversion' stamp: 'OliFlueckiger 8/24/2011 16:59'!
accessAt: anIndex
	^ P4TACVariableAccess new index: anIndex ; variable: self! !

!P4TACAbstractVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 8/24/2011 16:59'!
accessClass
	^ self accessAt: P4SmalltalkConfiguration classIndex ! !

!P4TACAbstractVariable methodsFor: 'conversion' stamp: 'OliFlueckiger 8/4/2011 16:13'!
asAlias
	^ P4TACVariableAlias new variable: self! !

!P4TACAbstractVariable methodsFor: 'liveness' stamp: 'OliFlueckiger 6/9/2011 17:14'!
assignedAt: num  ! !

!P4TACAbstractVariable methodsFor: 'liveness' stamp: 'OliFlueckiger 6/9/2011 17:25'!
isUnused 
	^false! !

!P4TACAbstractVariable methodsFor: 'liveness' stamp: 'OliFlueckiger 7/26/2011 15:10'!
isUsed 
	^self isUnused not! !

!P4TACAbstractVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 6/9/2011 16:45'!
name 
	^name! !

!P4TACAbstractVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 6/9/2011 16:45'!
name: aName
	name := aName asSymbol! !

!P4TACAbstractVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 7/29/2011 07:30'!
pop
	self register ifNil: [ self error: 'pop cannot be called before register allocation' ].
	^ P4TACPop new register: self register.! !

!P4TACAbstractVariable methodsFor: 'printing' stamp: 'OliFlueckiger 8/5/2011 16:19'!
printOn: stream 
	(self name isKindOf: String) ifFalse: [ ^ stream << name class asString ].
	stream << self name.! !

!P4TACAbstractVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 6/9/2011 19:24'!
printRegisterOn: stream
	self hasRegisterAssigned ifFalse: [ ^ stream << 'n/a']  .
	self asAsm printOn: stream! !

!P4TACAbstractVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 8/4/2011 12:10'!
push
	^ P4TACPush new variable: self.! !

P4TACAbstractVariable subclass: #P4TACFixedVariable
	instanceVariableNames: 'register'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

P4TACFixedVariable subclass: #P4TACArgument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACArgument methodsFor: 'liveness' stamp: 'OliFlueckiger 5/31/2011 14:02'!
isUnused
	"arguments are used to pass to another function, therefore they are used by definition, even if they are not used in the current context" 
	^ false! !

!P4TACFixedVariable class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/10/2012 18:53'!
register: aRegister
	^ self new register: aRegister! !

!P4TACFixedVariable class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/10/2012 19:03'!
register: aRegister name: aString
	^ self new 
			initRegister: aRegister; 
			name: aString;
			yourself! !

!P4TACFixedVariable class methodsFor: 'instance creation' stamp: 'OliFlueckiger 6/9/2011 17:38'!
withRegister: aRegister
	^ (self new) initRegister: aRegister! !

!P4TACFixedVariable methodsFor: 'accessing' stamp: 'CamilloBruni 4/3/2012 15:27'!
asAsm 
	register ifNil: [ self error: 'this variable ', self name, ' is not assigned to a register. is it live?' ].
	^ self register! !

!P4TACFixedVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 6/9/2011 19:24'!
hasRegisterAssigned 
	^true! !

!P4TACFixedVariable methodsFor: 'accessing' stamp: 'CamilloBruni 4/3/2012 15:39'!
initRegister: aRegister
	register ifNotNil: [ self error: 'register already assigned' ].
	register := aRegister! !

!P4TACFixedVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 6/9/2011 17:00'!
register 
	^ register! !

P4TACFixedVariable subclass: #P4TACResultVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACResultVariable methodsFor: 'acessing' stamp: 'OliFlueckiger 5/31/2011 16:46'!
name
	^ #res! !

!P4TACResultVariable methodsFor: 'acessing' stamp: 'OliFlueckiger 7/25/2011 14:08'!
staticType 
	^nil! !

!P4TACResultVariable methodsFor: 'acessing' stamp: 'OliFlueckiger 7/25/2011 14:07'!
typeHint 
	^nil! !

P4TACFixedVariable subclass: #P4TACVariable
	instanceVariableNames: 'firstAssign lastAssign lastUse methodCalled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

P4TACVariable subclass: #P4TACConstantLocal
	instanceVariableNames: 'remote'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACConstantLocal methodsFor: 'accessing' stamp: 'OliFlueckiger 8/4/2011 15:41'!
beRemote 
! !

!P4TACConstantLocal methodsFor: 'accessing' stamp: 'OliFlueckiger 8/4/2011 16:19'!
name: aName
	name := aName! !

!P4TACConstantLocal methodsFor: 'accessing' stamp: 'OliFlueckiger 8/4/2011 15:29'!
shouldBeRemote 
	^ false! !

P4TACVariable subclass: #P4TACExternalizableVariable
	instanceVariableNames: 'remote'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACExternalizableVariable methodsFor: 'conversion' stamp: 'OliFlueckiger 8/29/2011 18:19'!
accept: aVisitor
	self shouldBeRemote ifTrue: [ ^ aVisitor visitVariableAccess: self remote ].
	^ super accept: aVisitor.  ! !

!P4TACExternalizableVariable methodsFor: 'conversion' stamp: 'OliFlueckiger 6/9/2011 17:30'!
asAsm
	self shouldBeRemote ifTrue: [ ^ self remote asAsm ] .
	^ super asAsm.
! !

!P4TACExternalizableVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 6/9/2011 16:59'!
beRemote
	remote := true! !

!P4TACExternalizableVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 6/9/2011 16:59'!
index
	self shouldBeRemote ifTrue: [ ^ remote index ].
	self error: 'no access'! !

!P4TACExternalizableVariable methodsFor: 'testing' stamp: 'OliFlueckiger 6/9/2011 17:00'!
isDoubleAccess
	self shouldBeRemote ifTrue:  [ ^ remote isDoubleAccess ].
	^ false.! !

!P4TACExternalizableVariable methodsFor: 'printing' stamp: 'OliFlueckiger 6/9/2011 17:35'!
printOn: stream
	self shouldBeRemote ifTrue: [ stream << '@' ].
	super printOn: stream  ! !

!P4TACExternalizableVariable methodsFor: 'printing' stamp: 'OliFlueckiger 6/9/2011 20:26'!
printRegisterOn: stream
	self hasRegisterAssigned
		ifTrue: [	^super printRegisterOn: stream ].
	self shouldBeRemote
		ifTrue: [	
			remote == true ifTrue: [ ^ stream << 'n/a'].
			^ remote printRegisterOn: stream ].
	stream << 'n/a'! !

!P4TACExternalizableVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 6/9/2011 17:00'!
remote
	^ remote! !

!P4TACExternalizableVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 6/9/2011 17:00'!
remote: aRemoteArray
	remote := aRemoteArray! !

!P4TACExternalizableVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 8/29/2011 20:04'!
remoteIndex: next
	(remote isKindOf: P4TACValue) ifTrue: [^remote index].
	^ next! !

!P4TACExternalizableVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 6/9/2011 17:01'!
remoteVariable
	^ remote variable! !

!P4TACExternalizableVariable methodsFor: 'testing' stamp: 'OliFlueckiger 6/9/2011 17:01'!
shouldBeRemote
	^ remote isNil not! !

!P4TACExternalizableVariable methodsFor: 'accessing' stamp: 'OliFlueckiger 6/9/2011 18:35'!
variable
	self shouldBeRemote ifTrue: [ ^ remote variable ].
	self error: 'Not an access'.! !

P4TACExternalizableVariable subclass: #P4TACLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

P4TACExternalizableVariable subclass: #P4TACVariableAlias
	instanceVariableNames: 'variable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACVariableAlias methodsFor: 'liveness' stamp: 'OliFlueckiger 6/9/2011 18:36'!
assignedAt: number
	" Aliases you assign to will become remote. Then they behave like variable access. See variable access for more info. "
	super assignedAt: number.
	self usedAt: number.
	variable beRemote! !

!P4TACVariableAlias methodsFor: 'liveness' stamp: 'OliFlueckiger 6/9/2011 18:27'!
beRemote
	variable beRemote! !

!P4TACVariableAlias methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 15:06'!
fixedType
	^ variable fixedType! !

!P4TACVariableAlias methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 15:06'!
fixedType: aType
	^ variable fixedType: aType! !

!P4TACVariableAlias methodsFor: 'accessing' stamp: 'OliFlueckiger 6/9/2011 18:37'!
initialize 
	super initialize .
	lastAssign := firstAssign := 0.! !

!P4TACVariableAlias methodsFor: 'testing' stamp: 'OliFlueckiger 8/24/2011 14:27'!
isUnused 
	^false! !

!P4TACVariableAlias methodsFor: 'accessing' stamp: 'OliFlueckiger 5/31/2011 17:00'!
name
	^ variable name.! !

!P4TACVariableAlias methodsFor: 'printing' stamp: 'OliFlueckiger 5/31/2011 16:57'!
printOn: stream
	variable printOn: stream.
	stream << '`'  ! !

!P4TACVariableAlias methodsFor: 'accessing' stamp: 'OliFlueckiger 8/29/2011 20:02'!
remoteIndex: next
	^ variable remoteIndex: next    ! !

!P4TACVariableAlias methodsFor: 'testing' stamp: 'OliFlueckiger 5/31/2011 16:38'!
shouldBeRemote
	^ variable shouldBeRemote ! !

!P4TACVariableAlias methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 15:05'!
typeHint 
	^ variable typeHint ! !

!P4TACVariableAlias methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 15:07'!
typeHint: hint
	^ variable typeHint: hint ! !

!P4TACVariableAlias methodsFor: 'accessing' stamp: 'ToonVerwaest 5/27/2011 14:59'!
variable: aVariable
	variable := aVariable ! !

P4TACVariable subclass: #P4TACRemoteArray
	instanceVariableNames: 'remotes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACRemoteArray methodsFor: 'accessing' stamp: 'OliFlueckiger 8/29/2011 20:02'!
add: aValue
	| result |
	result := self accessAt: (aValue remoteIndex: remotes size). 
	remotes add: aValue.
	^ result! !

!P4TACRemoteArray methodsFor: 'accessing' stamp: 'OliFlueckiger 6/10/2011 14:15'!
canBeVolatile 
	"remotes are inserted after liveness analysis. 
	we therefore cannot know if there are methods called within their lifespan"
	^false! !

!P4TACRemoteArray methodsFor: 'iterating' stamp: 'ToonVerwaest 5/28/2011 14:14'!
do: aBlock
	^ remotes do: aBlock! !

!P4TACRemoteArray methodsFor: 'initialize-release' stamp: 'OliFlueckiger 6/16/2011 18:44'!
initialize
	remotes := OrderedCollection new.
	self assignedAt: 1.  ! !

!P4TACRemoteArray methodsFor: 'testing' stamp: 'ToonVerwaest 5/28/2011 14:13'!
isEmpty
	^ remotes isEmpty! !

!P4TACRemoteArray methodsFor: 'accessing' stamp: 'ToonVerwaest 5/28/2011 14:26'!
name
	^ #'_remote_'! !

!P4TACRemoteArray methodsFor: 'accessing' stamp: 'OliFlueckiger 5/31/2011 17:47'!
size
	^ remotes size! !

P4TACVariable subclass: #P4TACSelf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACSelf methodsFor: 'testing' stamp: 'OliFlueckiger 7/22/2011 15:43'!
firstAssign 
	^ 1! !

!P4TACSelf methodsFor: 'testing' stamp: 'OliFlueckiger 6/9/2011 21:13'!
isConstant
	^ true! !

!P4TACSelf methodsFor: 'testing' stamp: 'OliFlueckiger 8/29/2011 13:58'!
isSelf
	^true! !

!P4TACSelf methodsFor: 'testing' stamp: 'OliFlueckiger 8/24/2011 17:30'!
shouldBeRemote 
	^false! !

P4TACVariable subclass: #P4TACTemp
	instanceVariableNames: 'local'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

P4TACTemp subclass: #P4TACClosureTemp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACClosureTemp methodsFor: 'type' stamp: 'OliFlueckiger 12/7/2011 22:21'!
wrapTypeGuard: types andCondition: condition around: aBlock fallback: anOtherBlock with: helper
	(types anySatisfy: [ :type | P4Closure asPClass == type ])
		ifTrue: [ ^ aBlock value.].
	anOtherBlock value.! !

!P4TACTemp methodsFor: 'testing' stamp: 'OliFlueckiger 6/9/2011 19:42'!
isConstant
	^ true! !

!P4TACVariable methodsFor: 'visiting' stamp: 'OliFlueckiger 6/9/2011 17:22'!
assignRegister: aRegister for: aRegisterAllocator
	aRegisterAllocator assignRegister: aRegister to: self.! !

!P4TACVariable methodsFor: 'liveness' stamp: 'OliFlueckiger 6/9/2011 17:22'!
assignedAt: number
	(firstAssign isNil or: [ firstAssign > number ]) ifTrue: [ firstAssign := number ].
	lastAssign := number! !

!P4TACVariable methodsFor: 'liveness' stamp: 'OliFlueckiger 6/10/2011 13:36'!
canBeVolatile
	methodCalled ifNotNil: [
		^ (lastUse <= methodCalled) ].
	^ true.! !

!P4TACVariable methodsFor: 'liveness' stamp: 'OliFlueckiger 6/9/2011 17:22'!
firstAssign
	^ firstAssign! !

!P4TACVariable methodsFor: 'testing' stamp: 'OliFlueckiger 6/9/2011 19:24'!
hasRegisterAssigned
	^ self register ~~ nil! !

!P4TACVariable methodsFor: 'liveness' stamp: 'OliFlueckiger 6/9/2011 17:22'!
index
	self error: 'no access'! !

!P4TACVariable methodsFor: 'testing' stamp: 'OliFlueckiger 6/9/2011 17:22'!
isAccess
	^ self asAsm isAccess! !

!P4TACVariable methodsFor: 'liveness' stamp: 'OliFlueckiger 8/29/2011 13:58'!
isSelf 
	 ^ false! !

!P4TACVariable methodsFor: 'liveness' stamp: 'OliFlueckiger 6/9/2011 17:23'!
isUnused
	^ self lastUse isNil ! !

!P4TACVariable methodsFor: 'liveness' stamp: 'OliFlueckiger 6/9/2011 17:23'!
lastAssign
	^ lastAssign! !

!P4TACVariable methodsFor: 'liveness' stamp: 'OliFlueckiger 6/9/2011 17:23'!
lastUse
	^ lastUse! !

!P4TACVariable methodsFor: 'liveness' stamp: 'OliFlueckiger 6/10/2011 13:46'!
methodCalled: pos
	firstAssign ifNotNil: [ methodCalled ifNil: [methodCalled := pos]].! !

!P4TACVariable methodsFor: 'printing' stamp: 'OliFlueckiger 6/9/2011 19:24'!
printRegisterOn: stream
	(self hasRegisterAssigned )
		ifTrue: [	self asAsm printOn: stream ]
		ifFalse: [ stream << 'n/a' ]! !

!P4TACVariable methodsFor: 'accessing' stamp: 'CamilloBruni 4/3/2012 15:39'!
register: aRegister
	register := aRegister! !

!P4TACVariable methodsFor: 'liveness' stamp: 'OliFlueckiger 8/24/2011 17:37'!
usedAt: number
	lastUse ifNotNil: [(number < lastUse) ifTrue: [ ^self ]].
	lastUse := number! !

P4TACAbstractVariable subclass: #P4TACVariableAccess
	instanceVariableNames: 'index variable cachedRegister'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACVariableAccess methodsFor: 'accessing' stamp: 'ToonVerwaest 5/29/2011 11:51'!
accept: aVisitor
	^ aVisitor visitVariableAccess: self  ! !

!P4TACVariableAccess methodsFor: 'accessing' stamp: 'CamilloBruni 6/15/2012 18:05'!
asAsm
	^ cachedRegister
		ifNil: [ cachedRegister := variable asAsm accessAt: index]! !

!P4TACVariableAccess methodsFor: 'liveness' stamp: 'ToonVerwaest 5/28/2011 18:40'!
assignedAt: number
	" when you assign to a variable[], then you actually use the variable "
	variable usedAt: number! !

!P4TACVariableAccess methodsFor: 'testing' stamp: 'OliFlueckiger 6/9/2011 19:24'!
hasRegisterAssigned 
	^ variable hasRegisterAssigned ! !

!P4TACVariableAccess methodsFor: 'accessing' stamp: 'OliFlueckiger 5/12/2011 18:17'!
index
	^ index! !

!P4TACVariableAccess methodsFor: 'accessing' stamp: 'OliFlueckiger 5/12/2011 18:17'!
index: anObject
	index := anObject! !

!P4TACVariableAccess methodsFor: 'testing' stamp: 'ToonVerwaest 5/12/2011 22:45'!
isAccess
	^ true! !

!P4TACVariableAccess methodsFor: 'testing' stamp: 'OliFlueckiger 5/19/2011 14:03'!
isDoubleAccess
	^ variable isAccess ! !

!P4TACVariableAccess methodsFor: 'liveness' stamp: 'OliFlueckiger 8/5/2011 17:23'!
isUnused 
	^variable isUnused! !

!P4TACVariableAccess methodsFor: 'accessing' stamp: 'OliFlueckiger 5/12/2011 19:02'!
name
	^ variable name! !

!P4TACVariableAccess methodsFor: 'accessing' stamp: 'OliFlueckiger 5/31/2011 12:42'!
printOn: stream
	variable printOn: stream.
	stream <<  '->' << index.! !

!P4TACVariableAccess methodsFor: 'accessing' stamp: 'OliFlueckiger 5/31/2011 18:38'!
register
	^ variable register ! !

!P4TACVariableAccess methodsFor: 'liveness' stamp: 'ToonVerwaest 5/27/2011 17:29'!
usedAt: number
	variable usedAt: number  ! !

!P4TACVariableAccess methodsFor: 'accessing' stamp: 'OliFlueckiger 5/16/2011 19:26'!
variable
	^ variable ! !

!P4TACVariableAccess methodsFor: 'accessing' stamp: 'OliFlueckiger 5/12/2011 19:01'!
variable: anObject
	variable := anObject! !

P4TACValue subclass: #P4TACConstant
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACConstant class methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 5/5/2011 01:11'!
with: aValue
	^ (self new) value: aValue ! !

!P4TACConstant methodsFor: 'accessing' stamp: 'ToonVerwaest 5/6/2011 19:57'!
accept: aVisitor
	^ aVisitor visitConstant: self! !

!P4TACConstant methodsFor: 'accessing' stamp: 'ToonVerwaest 5/6/2011 22:33'!
constantValue
	^ value! !

!P4TACConstant methodsFor: 'testing' stamp: 'ToonVerwaest 5/12/2011 22:45'!
isAccess
	^ false! !

!P4TACConstant methodsFor: 'testing' stamp: 'ToonVerwaest 7/18/2011 22:13'!
isConstant
	^ true! !

!P4TACConstant methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 17:48'!
isStaticallyTyped
	^ false! !

!P4TACConstant methodsFor: 'printing' stamp: 'OliFlueckiger 5/6/2011 17:29'!
printOn: stream 
	stream << '"'.
	value printOn: stream.
	 stream << '"'.! !

!P4TACConstant methodsFor: 'printing' stamp: 'OliFlueckiger 5/5/2011 01:09'!
printString 
	^ '"',value printString ,'"'! !

!P4TACConstant methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 17:50'!
value: aValue
	(aValue isKindOf: SmallInteger) ifTrue: [
		typeHint := P4Package byPathName: #'Kernel.Number.SmallInteger' ].    
	value := aValue! !

!P4TACConstant methodsFor: 'accessing' stamp: 'OliFlueckiger 12/7/2011 22:21'!
wrapTypeGuard: types andCondition: condition around: aBlock fallback: anOtherBlock with: helper
	(types anySatisfy: [ :type | value pclass == type ])
		ifTrue: [ 
			aBlock value.
			^ condition ifNotEmpty: [ helper insertCondition: condition fallback: anOtherBlock ]].
	anOtherBlock value.! !

P4TACValue subclass: #P4TACMethodObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACMethodObject class methodsFor: 'instance creation' stamp: 'OliFlueckiger 6/22/2011 16:00'!
with: aValue
	^ self new target: aValue  ! !

!P4TACMethodObject methodsFor: 'visiting' stamp: 'OliFlueckiger 6/22/2011 17:24'!
accept: aVisitor
	self error: 'can only be accessed'! !

!P4TACMethodObject methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2012 19:09'!
accessAt: anIndex
	^ P4TACMethodObjectAccess method: self index: anIndex ! !

!P4TACMethodObject methodsFor: 'testing' stamp: 'ToonVerwaest 5/12/2011 22:45'!
isAccess
	^ true! !

P4TACValue subclass: #P4TACMethodObjectAccess
	instanceVariableNames: 'methodObject index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACMethodObjectAccess class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/10/2012 19:09'!
method: aMethod index: aNumber
	^ self new
		method: aMethod;
		index: aNumber;
		yourself! !

!P4TACMethodObjectAccess methodsFor: 'visiting' stamp: 'OliFlueckiger 6/22/2011 15:51'!
accept: aVisitor
	^ aVisitor visitMethodObjectAccess: self! !

!P4TACMethodObjectAccess methodsFor: 'accessing' stamp: 'OliFlueckiger 6/15/2011 16:54'!
index
	^ index! !

!P4TACMethodObjectAccess methodsFor: 'accessing' stamp: 'OliFlueckiger 6/15/2011 16:54'!
index: anObject
	index := anObject! !

!P4TACMethodObjectAccess methodsFor: 'accessing' stamp: 'OliFlueckiger 6/22/2011 15:58'!
method: aMethodObject
	methodObject := aMethodObject! !

!P4TACMethodObjectAccess methodsFor: 'printing' stamp: 'OliFlueckiger 6/22/2011 15:59'!
printOn: stream
	methodObject printOn: stream.
	stream << '[' << index << ']'! !

!P4TACMethodObjectAccess methodsFor: 'accessing' stamp: 'OliFlueckiger 7/14/2011 18:43'!
target
	^ methodObject    ! !

P4TACValue subclass: #P4TACReference
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

P4TACReference subclass: #P4TACExternalReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACExternalReference methodsFor: 'visiting' stamp: 'ToonVerwaest 6/17/2011 20:02'!
accept: visitor
	^ visitor visitConstantReference: self! !

!P4TACExternalReference methodsFor: 'testing' stamp: 'ToonVerwaest 7/18/2011 22:30'!
isConstant
	^ true! !

!P4TACExternalReference methodsFor: 'testing' stamp: 'OliFlueckiger 12/7/2011 22:21'!
wrapTypeGuard: types andCondition: condition around: aBlock fallback: anOtherBlock with: helper
	(types anySatisfy: [ :type | target pclass == type ])
		ifTrue: [ 
			aBlock value.
			^ condition ifNotEmpty: [ helper insertCondition: condition fallback: anOtherBlock ]].
	anOtherBlock value.! !

!P4TACReference class methodsFor: 'instance creation' stamp: 'ToonVerwaest 6/10/2011 16:27'!
target: aTarget
	^ self new target: aTarget! !

!P4TACReference methodsFor: 'accessing' stamp: 'OliFlueckiger 6/7/2011 14:29'!
accept: visitor
	^ visitor visitReference: self! !

!P4TACReference methodsFor: 'accessing' stamp: 'OliFlueckiger 6/7/2011 15:15'!
printOn: stream 
	stream << '&' << target asString .! !

!P4TACReference methodsFor: 'accessing' stamp: 'OliFlueckiger 6/7/2011 14:22'!
target
	^ target! !

!P4TACReference methodsFor: 'accessing' stamp: 'OliFlueckiger 6/7/2011 14:22'!
target: anObject
	target := anObject! !

!P4TACValue methodsFor: 'testing' stamp: 'OliFlueckiger 5/24/2011 19:07'!
asAsm 
	^ self! !

!P4TACValue methodsFor: 'visiting' stamp: 'ToonVerwaest 5/16/2011 18:43'!
asValue
	^self! !

!P4TACValue methodsFor: 'accessing' stamp: 'OliFlueckiger 7/25/2011 14:08'!
hasTypeHint
	^ self typeHint ~~ nil! !

!P4TACValue methodsFor: 'testing' stamp: 'ToonVerwaest 5/12/2011 22:45'!
isAccess
	^ false! !

!P4TACValue methodsFor: 'testing' stamp: 'OliFlueckiger 5/7/2011 02:17'!
isConstant 
	^ false! !

!P4TACValue methodsFor: 'testing' stamp: 'OliFlueckiger 5/19/2011 14:04'!
isDoubleAccess
	^ false! !

!P4TACValue methodsFor: 'accessing' stamp: 'OliFlueckiger 7/25/2011 14:08'!
isStaticallyTyped
	^ self staticType ~~ nil! !

!P4TACValue methodsFor: 'instruction-creation' stamp: 'ToonVerwaest 6/17/2011 15:11'!
loadAddressIn: aVariable
	^P4TACLoadAddress load: self in: aVariable ! !

!P4TACValue methodsFor: 'accessing' stamp: 'OliFlueckiger 7/25/2011 16:08'!
moveTo: aVariable
	self hasTypeHint ifTrue: [ aVariable typeHint: self typeHint ].
	self isStaticallyTyped ifTrue: [ aVariable staticType: self staticType ].
	^P4TACAssignment move: self to: aVariable  
! !

!P4TACValue methodsFor: 'printing' stamp: 'OliFlueckiger 5/31/2011 13:12'!
printRegisterOn: stream  
	stream << 'n/a' ! !

!P4TACValue methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 16:11'!
staticType
	^ staticType! !

!P4TACValue methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 16:11'!
staticType: anObject
	(self hasTypeHint and: [ typeHint ~~ anObject ]) ifTrue: [ self error: 'trying to change the type of a variable']. 
	staticType := anObject! !

!P4TACValue methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 16:11'!
typeHint
	^ typeHint! !

!P4TACValue methodsFor: 'accessing' stamp: 'OliFlueckiger 7/22/2011 16:49'!
typeHint: anObject
	(self hasTypeHint and: [ typeHint ~~ anObject ]) ifTrue: [ self error: 'not allowed to change type of ', self asString ,' from ',self typeHint asString,' to ',anObject asString ].  
	typeHint := anObject! !

!P4TACValue methodsFor: 'liveness' stamp: 'ToonVerwaest 5/27/2011 17:38'!
usedAt: number  ! !

!P4TACValue methodsFor: 'testing' stamp: 'OliFlueckiger 8/29/2011 15:03'!
wrapTypeGuard: types andCondition: conditions around: aBlock fallback: anOtherBlock with: helper
	^ helper insertTypeGuard: types andCondition: conditions for: self around: aBlock fallback: anOtherBlock! !

!P4TACValue methodsFor: 'testing' stamp: 'OliFlueckiger 8/29/2011 11:41'!
wrapTypeGuard: types around: aBlock fallback: anOtherBlock with: helper
	^ self wrapTypeGuard: types andCondition: {} around: aBlock fallback: anOtherBlock with: helper! !

P4Object subclass: #P4TACVariableName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

P4TACVariableName class
	instanceVariableNames: 'inst'!

P4TACVariableName class
	instanceVariableNames: 'inst'!

P4TACVariableName subclass: #P4TACBasePointerName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

P4TACVariableName subclass: #P4TACReturnTokenName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC-Values'!

!P4TACVariableName class methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 8/5/2011 12:28'!
instance
	^ inst ifNil: [ ^ inst := self new]! !

!P4TACVariableName methodsFor: 'accessing' stamp: 'OliFlueckiger 8/5/2011 12:28'!
name
	^ self! !

RBProgramNodeVisitor subclass: #P4AST2TAC
	instanceVariableNames: 'builder closureCaptures helper callable currentInstVars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

P4AST2TAC subclass: #P4A2TClosure
	instanceVariableNames: 'methodCompiler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

!P4A2TClosure methodsFor: 'accessing' stamp: 'ToonVerwaest 5/25/2011 18:33'!
builder: anObject
	builder := anObject! !

!P4A2TClosure methodsFor: 'accessing' stamp: 'OliFlueckiger 5/26/2011 16:40'!
closures: anObject
	closureCaptures := anObject! !

!P4A2TClosure methodsFor: 'compiling' stamp: 'ToonVerwaest 6/24/2011 19:52'!
compile: aClosure
	callable := aClosure.
	self compileCallable: aClosure code! !

!P4A2TClosure methodsFor: 'compiling' stamp: 'OliFlueckiger 8/24/2011 15:21'!
declareInstVars 
	builder loadSelf: #self from: [callable import: #self].
	builder clearInstVars.! !

!P4A2TClosure methodsFor: 'compiling' stamp: 'OliFlueckiger 7/29/2011 10:39'!
emptyBody
	builder return: (builder global: #nil)! !

!P4A2TClosure methodsFor: 'compiling' stamp: 'CamilloBruni 4/10/2012 19:13'!
insertReturn: lastResult
	"for a block the default method is the result of the last expression"
	builder return: lastResult.! !

!P4A2TClosure methodsFor: 'visitor' stamp: 'OliFlueckiger 8/24/2011 14:44'!
loadIncomingArguments: parameters 
	| numOfArgs aLocal i |

	"arg 1 is the closure"
	numOfArgs := parameters size + 1.
	i := 0.
	parameters do: [ :arg |
		aLocal := builder declare: arg name.
		i := i + 1.
		builder move: ( helper arg: i + 1 of: numOfArgs ) to: aLocal ]. 
	
	builder volatileFence ! !

!P4A2TClosure methodsFor: 'visitor' stamp: 'OliFlueckiger 8/24/2011 14:28'!
lookupLValue: anASTVariable
	^ builder local: anASTVariable name ifAbsent: [
		(callable import: anASTVariable name) ifNil: [
			builder instVar: anASTVariable name ]]! !

!P4A2TClosure methodsFor: 'accessing' stamp: 'ToonVerwaest 5/25/2011 17:42'!
methodCompiler: aMethodCompiler
	methodCompiler := aMethodCompiler! !

!P4A2TClosure methodsFor: 'accessing' stamp: 'ToonVerwaest 5/25/2011 17:41'!
methodSuper
	^ methodCompiler methodSuper! !

!P4A2TClosure methodsFor: 'visitor' stamp: 'OliFlueckiger 8/5/2011 12:05'!
storeBasePointer ! !

!P4A2TClosure methodsFor: 'visitor' stamp: 'OliFlueckiger 8/5/2011 15:55'!
visitReturnExpression: aReturnExpression
	| ret |
	ret := aReturnExpression expression accept: self.
	builder move: (callable returnTokenFor: self) to: (helper arg: 1 of: 1).
	builder move: ret to: helper resultVariable. 
	builder directCall: (P4Closure earlySelectorAddress: #return).
	^ ret! !

!P4A2TClosure methodsFor: 'visitor' stamp: 'CamilloBruni 12/15/2011 23:43'!
visitReturnNode: aReturnNode
	| ret |
	ret := aReturnNode value accept: self.
	builder move: (callable returnTokenFor: self) to: (helper arg: 1 of: 1).
	builder move: ret to: helper resultVariable. 
	builder directCall: (P4Closure earlySelectorAddress: #return).
	^ ret! !

!P4A2TClosure methodsFor: 'visitor' stamp: 'CamilloBruni 2/6/2012 14:06'!
visitSelfNode: aSelf
	^ builder local: #self ifAbsent: [
		callable import: #self ]! !

!P4A2TClosure methodsFor: 'visitor' stamp: 'abc 2/6/2012 16:18'!
visitVariableNode: anASTVariable
	^ builder local: anASTVariable name ifAbsent: [
		(callable import: anASTVariable name) ifNil: [
			builder instVarOrGlobal: anASTVariable name ]]! !

P4AST2TAC subclass: #P4A2TMethod
	instanceVariableNames: 'closureCompiler host'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-TAC'!

!P4A2TMethod methodsFor: 'compiling' stamp: 'OliFlueckiger 7/11/2011 12:24'!
compile: anAst
	self reset.
	^ self visit: anAst ! !

!P4A2TMethod methodsFor: 'visitor' stamp: 'ToonVerwaest 6/7/2011 17:39'!
compileClosureCapture: closureCapture
	closureCompiler compile: closureCapture closure.! !

!P4A2TMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 7/28/2011 16:42'!
compileInvokeBlock 
	helper invokeBlockFor: callable  ! !

!P4A2TMethod methodsFor: 'visitor' stamp: 'OliFlueckiger 9/7/2011 13:30'!
createNonLocalReturnToken
	callable entry positionAtBeginning.
	callable entry     
		<< (P4TACCall to: #newClosureReturnToken);
		<< (helper resultVariable moveTo:  (callable returnToken));
		<< (callable returnToken moveTo:  (callable basePointer accessAt: 0));
		<< ((callable basePointer) moveTo: (callable returnToken accessAt: 0))

! !

!P4A2TMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 9/8/2011 14:09'!
declareInstVars
	builder declareSelf: #self.
	builder declareInstVars: currentInstVars.
	callable locals at: P4TACBasePointerName instance put: (P4TACConstantLocal named: P4TACBasePointerName instance).
	callable locals at: P4TACReturnTokenName instance put: (P4TACConstantLocal named: P4TACReturnTokenName instance)..
	helper currentHost: host.! !

!P4A2TMethod methodsFor: 'compiling' stamp: 'OliFlueckiger 5/26/2011 15:05'!
emptyBody
	builder return: builder self  ! !

!P4A2TMethod methodsFor: 'accessing' stamp: 'ToonVerwaest 5/25/2011 18:38'!
helper: aHelper
	helper := aHelper.
	closureCompiler helper: aHelper.
	aHelper
		builder: builder;
		methodCompiler: self.! !

!P4A2TMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 7/11/2011 12:22'!
host: aClass
	host := aClass.
! !

!P4A2TMethod methodsFor: 'initialize-release' stamp: 'ToonVerwaest 6/24/2011 20:01'!
initialize
	builder := P4TACBuilder new.
	closureCaptures := OrderedCollection new.
	closureCompiler := P4A2TClosure new
							builder: builder;
							closures: closureCaptures;
							methodCompiler: self.! !

!P4A2TMethod methodsFor: 'visitor' stamp: 'OliFlueckiger 9/7/2011 14:40'!
insertPopArguments
	helper insertPopArguments! !

!P4A2TMethod methodsFor: 'visitor' stamp: 'CamilloBruni 4/12/2012 16:22'!
insertPreamble
	callable preamble: builder preamble.
	helper insertMethodPreamble: callable.! !

!P4A2TMethod methodsFor: 'compiling' stamp: 'CamilloBruni 4/10/2012 19:12'!
insertReturn: lastResult
	"for a method the default return value is bound to self"
	builder return: builder self! !

!P4A2TMethod methodsFor: 'visitor' stamp: 'OliFlueckiger 5/31/2011 13:43'!
loadIncomingArguments: parameters
	^ helper loadMethodArguments: parameters! !

!P4A2TMethod methodsFor: 'accessing' stamp: 'ToonVerwaest 5/26/2011 17:39'!
method
	^ callable! !

!P4A2TMethod methodsFor: 'accessing' stamp: 'OliFlueckiger 7/26/2011 17:47'!
methodSuper
	^ callable host superclass! !

!P4A2TMethod methodsFor: 'accessing' stamp: 'CamilloBruni 12/14/2011 16:02'!
numArgs
	^ callable message numArgs + 1! !

!P4A2TMethod methodsFor: 'accessing' stamp: 'CamilloBruni 12/14/2011 16:07'!
readAnnotations: aCallable  
	aCallable pragmas do: [ :a | a accept: self ].! !

!P4A2TMethod methodsFor: 'initialize-release' stamp: 'ToonVerwaest 6/24/2011 20:00'!
reset
	builder reset.
	callable := P4TACMethod new.
	closureCaptures removeAll.! !

!P4A2TMethod methodsFor: 'convenience' stamp: 'OliFlueckiger 8/5/2011 17:27'!
storeBasePointer
	builder move: helper stackPointer to: callable basePointer! !

!P4A2TMethod methodsFor: 'compiling' stamp: 'OliFlueckiger 7/26/2011 17:06'!
unrollPrimitive
	helper unrollPrimitiveFor: callable! !

!P4A2TMethod methodsFor: 'visitor' stamp: 'ToonVerwaest 5/25/2011 18:44'!
visitKeywordAnnotation: anASTKeywordAnnotation
	^ helper annotation: anASTKeywordAnnotation
! !

!P4A2TMethod methodsFor: 'visitor' stamp: 'CamilloBruni 12/14/2011 15:58'!
visitMethodNode: aMethod
	| entry currentCapture |
	callable host: host.
	callable message: aMethod selector.
	
	self compileCallable: aMethod.
	
	[ closureCaptures isEmpty ] whileFalse: [
		currentCapture := closureCaptures removeFirst.
		self compileClosureCapture: currentCapture.
		callable addClosure: currentCapture closure. ].

	callable hasNonLocalReturn ifTrue: [ self createNonLocalReturnToken ].
				
	callable literals: builder literals.
	
	^ callable! !

!P4A2TMethod methodsFor: 'visitor' stamp: 'CamilloBruni 12/15/2011 16:58'!
visitPragma: anASTKeywordAnnotation
	^ helper annotation: anASTKeywordAnnotation
! !

!P4A2TMethod methodsFor: 'visitor' stamp: 'ToonVerwaest 5/25/2011 17:56'!
visitReturnExpression: aReturnExpression
	^ helper methodReturn: aReturnExpression! !

!P4A2TMethod methodsFor: 'visitor' stamp: 'CamilloBruni 12/15/2011 23:42'!
visitReturnNode: aReturnNode
	^ helper methodReturn: aReturnNode! !

!P4A2TMethod methodsFor: 'visitor' stamp: 'ToonVerwaest 5/25/2011 18:44'!
visitUnaryAnnotation: anASTUnaryAnnotation
	^ helper annotation: anASTUnaryAnnotation! !

!P4AST2TAC class methodsFor: 'accessing' stamp: 'ToonVerwaest 5/16/2011 23:04'!
pname
	<preventExport>
	^ pname ifNil: [ pname := (self name copyFrom: 'P4' size + 1 to: self name size) asSymbol ]! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 2/3/2012 15:02'!
acceptOnCollection: aCollection
	aCollection isNil
		ifTrue: [ ^ OrderedCollection new: 1 ].
	^ aCollection collect: [ :each | each accept: self ]! !

!P4AST2TAC methodsFor: 'convenience' stamp: 'CamilloBruni 12/14/2011 16:17'!
argumentsEmptyOrStatic: arguments
	^ arguments allSatisfy: [:arg | arg isDynamic not ]


! !

!P4AST2TAC methodsFor: 'convenience' stamp: 'OliFlueckiger 9/8/2011 13:50'!
callable 
	^callable! !

!P4AST2TAC methodsFor: 'compiling' stamp: 'CamilloBruni 4/10/2012 19:14'!
compileCallable: aCallable
	self prepareBuilderFor: aCallable.
	
	self declareInstVars.
	self insertPreamble.
	
	builder useAsNextBasicBlock: (callable registerPushing: builder nextBasicBlock).
	self storeBasePointer.
	
	self insertArgumentsOf: aCallable.
	self readAnnotations: aCallable.
	
	builder useAsNextBasicBlock: (callable primitiveCalling: builder nextBasicBlock).
	callable entry: builder nextBasicBlock.
	self unrollPrimitive.
	builder useAsNextBasicBlock: callable entry.
	
	self compileStatements: aCallable statements.
	builder endBlock.
	
	callable postamble: builder postamble.
	
	builder useAsNextBasicBlock: (callable popArguments: builder nextBasicBlock).
	self insertPopArguments.
	
	self compileInvokeBlock! !

!P4AST2TAC methodsFor: 'convenience' stamp: 'OliFlueckiger 7/28/2011 16:40'!
compileInvokeBlock ! !

!P4AST2TAC methodsFor: 'compiling' stamp: 'CamilloBruni 12/14/2011 16:20'!
compileStatements: statements
	|result|
	
	statements isEmpty ifTrue: [ ^ self emptyBody ].
	
	statements allButLastDo: [ :statement |
		statement acceptIgnoreResult: self ].
	
	result := statements last accept: self.
		
	statements last isReturn ifFalse: [
		self insertReturn: result ]! !

!P4AST2TAC methodsFor: 'compiling' stamp: 'OliFlueckiger 7/8/2011 13:19'!
currentInstVars: vars
	currentInstVars := vars! !

!P4AST2TAC methodsFor: 'compiling' stamp: 'OliFlueckiger 5/26/2011 15:04'!
emptyBody
	self subclassResponsibility! !

!P4AST2TAC methodsFor: 'convenience' stamp: 'OliFlueckiger 8/12/2011 17:26'!
evaluateArguments: arguments
	| argumentTemps argument value |
	argumentTemps := Array new: arguments size.
	1 to: arguments size - 1 do: [ :index |
		argument := arguments at: index.
		value := builder temporaryStore: (argument accept: self).
		argumentTemps at: index put: value ].
	argumentTemps at: arguments size put: (arguments last accept: self).
	
	^ argumentTemps! !

!P4AST2TAC methodsFor: 'accessing' stamp: 'ToonVerwaest 5/25/2011 18:02'!
helper: aHelper
	helper := aHelper! !

!P4AST2TAC methodsFor: 'compiling' stamp: 'CamilloBruni 4/10/2012 19:14'!
insertArgumentsOf: aCallable
	
	builder useAsNextBasicBlock: (callable argumentLoading: builder nextBasicBlock).
	self loadIncomingArguments: aCallable arguments! !

!P4AST2TAC methodsFor: 'convenience' stamp: 'OliFlueckiger 9/7/2011 14:40'!
insertPopArguments! !

!P4AST2TAC methodsFor: 'convenience' stamp: 'CamilloBruni 4/12/2012 16:22'!
insertPreamble
	callable preamble: builder preamble.! !

!P4AST2TAC methodsFor: 'compiling' stamp: 'OliFlueckiger 5/26/2011 15:04'!
insertReturn: lastValue
	self subclassResponsibility! !

!P4AST2TAC methodsFor: 'convenience' stamp: 'OliFlueckiger 5/31/2011 13:43'!
loadIncomingArguments: arguments
	self subclassResponsibility! !

!P4AST2TAC methodsFor: 'convenience' stamp: 'CamilloBruni 2/6/2012 14:06'!
lookupLValue: anASTVariable
	^ builder local: anASTVariable name ifAbsent: [
		builder instVar: anASTVariable name]! !

!P4AST2TAC methodsFor: 'accessing' stamp: 'ToonVerwaest 5/25/2011 17:35'!
methodSuper
	self subclassResponsibility! !

!P4AST2TAC methodsFor: 'compiling' stamp: 'CamilloBruni 4/10/2012 18:42'!
prepareBuilderFor: aCallable
	builder locals: callable locals.
	builder temps: callable temps.
	builder setMethodObject: callable.
	builder declareLocals: aCallable temporaries! !

!P4AST2TAC methodsFor: 'convenience' stamp: 'OliFlueckiger 7/22/2011 15:09'!
readAnnotations: aCallable  ! !

!P4AST2TAC methodsFor: 'convenience' stamp: 'CamilloBruni 4/10/2012 19:00'!
send: message to: receiver receiverTac: receiverTac with: arguments
	
	| receiverTemp argumentTemps ret tacMessage |
	"handle inlined / optimized message sends..."
	(helper implements: message selector ) ifTrue: [ 
		^ helper send: message to: receiver with: arguments for: self ].	
	
	receiverTemp := receiverTac 
		ifNil: [ receiver accept: self]
		ifNotNil: [ receiverTac].
	
	(self argumentsEmptyOrStatic: arguments)
		ifTrue: [ 
			argumentTemps := arguments collect: [ :arg | arg accept: self ]]
		ifFalse: [
			receiverTemp := builder temporaryStore: receiverTemp.
			argumentTemps := self evaluateArguments: arguments. ].
		
	tacMessage := P4TACMessage fromRBMessage: message.
		
	receiver isSuper 
		ifTrue: [ ^ self tacSuperSend: tacMessage to: receiverTemp with: argumentTemps ].
		
	^ self tacSend: tacMessage to: receiverTemp with: argumentTemps! !

!P4AST2TAC methodsFor: 'convenience' stamp: 'OliFlueckiger 10/5/2011 18:01'!
send: message to: receiver with: arguments
	^ self send: message to: receiver receiverTac: nil with: arguments! !

!P4AST2TAC methodsFor: 'convenience' stamp: 'OliFlueckiger 8/12/2011 15:34'!
tacSend: message to: receiver with: arguments
	builder volatileFence.
	helper loadArguments: arguments andReceiver: receiver toSend: message selector.
	
	helper invoke: message for: receiver with: arguments.
	^ helper resultVariable! !

!P4AST2TAC methodsFor: 'convenience' stamp: 'CamilloBruni 4/13/2012 14:19'!
tacSuperSend: message to: receiver with: arguments
	builder volatileFence.
	helper loadArguments: arguments andReceiver: receiver toSend: message selector.
	
	self flag: 'the super call should really not be looked up statically!!'.
	builder 
		move: (receiver accessAt: P4SmalltalkConfiguration classIndex) 
		to: helper resultVariable.
	builder directCall: (self methodSuper earlySelectorAddress: message selector).

	^ helper resultVariable! !

!P4AST2TAC methodsFor: 'compiling' stamp: 'OliFlueckiger 7/26/2011 17:05'!
unrollPrimitive! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 2/3/2012 15:02'!
visit: anASTNode
	^ anASTNode accept: self! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 6/15/2012 13:17'!
visitArgumentNode: anASTVariable
	^ self visitVariableNode: anASTVariable! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'OliFlueckiger 5/4/2011 17:08'!
visitArray: anArray
	self error: 'Literal arrays are not yet supported by the compiler. Patches welcome!!'! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'OliFlueckiger 6/9/2011 20:53'!
visitAssignmentExpression: anAssignmentExpression
	| value variable |
	variable := self lookupLValue: anAssignmentExpression variable.
	value := anAssignmentExpression expression accept: self.
	value := builder temporaryStore: value.  
	builder move: value to: variable.
	^ value
! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 12/15/2011 16:49'!
visitAssignmentNode: anAssignmentExpression
	| value variable |
	variable := self lookupLValue: anAssignmentExpression variable.
	value := anAssignmentExpression value accept: self.
	value := builder temporaryStore: value.  
	builder move: value to: variable.
	^ value
! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 12/15/2011 16:49'!
visitAssignmentStatement: anAssignmentNode
	| value variable |
	variable := self lookupLValue: anAssignmentNode variable.
	value := anAssignmentNode value accept: self.
	
	builder move: value to: variable.! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'OliFlueckiger 5/6/2011 16:17'!
visitBinaryExpression: aBinaryExpression
	^ self
		send: aBinaryExpression
		to: aBinaryExpression receiver
		with: { aBinaryExpression argument } 
! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 12/14/2011 17:07'!
visitBlockNode: aBlockNode
	| result |
	builder volatileFence.
	result := builder closure: aBlockNode inScope: callable.
	closureCaptures add: result.
	^ result resultVariable! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'OliFlueckiger 5/4/2011 17:08'!
visitBraceExpression: braceExpression
	self error: 'Brace expressions are not supported by the compiler. Patches welcome!!'! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 12/15/2011 23:58'!
visitCascadeNode: aCascadeNode
	| lastMessage receiver |
	receiver := builder temporaryStore: (aCascadeNode receiver accept: self).
	aCascadeNode messages do: [ :aMessageExpression |
		lastMessage := self send: aMessageExpression to: aCascadeNode receiver receiverTac: receiver with: aMessageExpression arguments ].
	^ lastMessage! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'ToonVerwaest 5/12/2011 22:37'!
visitCharacter: anASTCharacter
	^ builder loadConstant: anASTCharacter char! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'OliFlueckiger 6/10/2011 14:25'!
visitClosure: closure
	| result |
	builder volatileFence.
	result := builder closure: closure inScope: callable.
	closureCaptures add: result.
	^ result resultVariable! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'ToonVerwaest 5/12/2011 22:37'!
visitFloat: anASTFloat
	^ builder loadConstant: anASTFloat asNumber! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 12/14/2011 17:05'!
visitInlinedBlock: aBlock returnTo: aResultVariable
	| lastStatement |
	( aBlock statements size > 1 ) ifTrue: [
		aBlock statements allButLastDo: [ :statement |
			statement accept: self ]].
	
	( aBlock statements size > 0 ) 
		ifTrue: [
			lastStatement := aBlock statements last accept: self.
			lastStatement asValue 
				ifNil: [ builder move: builder nil to: aResultVariable ]
				ifNotNil: [ builder move: lastStatement asValue to: aResultVariable ]]
		ifFalse: [
			builder move: builder nil to: aResultVariable ].
	^ aResultVariable.
! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 4/13/2012 14:00'!
visitKeywordSelector: anASTKeywordSelector
	^ anASTKeywordSelector selectorSymbol! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 12/16/2011 00:01'!
visitLiteralNode: aLiteralNode
	| value |

	value := aLiteralNode value.

	(value = true)
		ifTrue: [ ^ builder instVarOrGlobal: #true ].
		
	(value = false)
		ifTrue: [  ^ builder instVarOrGlobal: #false ].
		
	(value = nil)
		ifTrue: [  ^ builder instVarOrGlobal: #nil ].
		 
	^ aLiteralNode value isInteger
		ifFalse: [ builder loadConstant: value ]
		ifTrue: [ P4TACConstant with: (value << 1) + 1 ]! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'OliFlueckiger 10/5/2011 18:02'!
visitMessageCascadeExpression: anASTMessageCascadeExpression
	| lastMessage receiver |
	receiver := builder temporaryStore: (anASTMessageCascadeExpression receiver accept: self).
	anASTMessageCascadeExpression cascades do: [ :aMessageExpression |
		lastMessage := self send: aMessageExpression to: anASTMessageCascadeExpression receiver receiverTac: receiver with: aMessageExpression arguments ].
	^ lastMessage! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'OliFlueckiger 5/6/2011 16:17'!
visitMessageExpression: aMessageExpression
	^ self
		send: aMessageExpression
		to: aMessageExpression receiver
		with: aMessageExpression arguments! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 12/14/2011 16:12'!
visitMessageNode: aMessageExpression
	^ self
		send: aMessageExpression
		to: aMessageExpression receiver
		with: aMessageExpression arguments! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 4/13/2012 14:00'!
visitNumber: anASTNumber
	self flag: 'Support bignums separately'.
	self halt.
	^ P4TACConstant with: (anASTNumber asNumber << 1) + 1! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 12/15/2011 16:51'!
visitPath: aPath
	self error: 'Not Yet Implemented'! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 12/15/2011 16:47'!
visitPragmaNode: aPragmaNode	
	"ignored"! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'ToonVerwaest 5/25/2011 17:56'!
visitReturnExpression: aReturnExpression
	self subclassResponsibility! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 12/15/2011 23:42'!
visitReturnNode: aReturnNode
	self subclassResponsibility! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 12/15/2011 14:18'!
visitSelfNode: aSelf
	^ builder self! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'ToonVerwaest 5/12/2011 22:37'!
visitString: anASTString
	^ builder loadConstant: anASTString string! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 12/15/2011 14:18'!
visitSuperNode: anASTSuper
	^ builder self! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'ToonVerwaest 5/12/2011 22:37'!
visitSymbol: anASTSymbol
	^ builder loadConstant: anASTSymbol symbol! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 6/15/2012 13:17'!
visitTemporaryNode: anASTVariable
	^ self visitVariableNode: anASTVariable! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'ToonVerwaest 5/25/2011 14:50'!
visitUnaryExpression: anASTUnaryExpression
	^ self
		send: anASTUnaryExpression
		to: anASTUnaryExpression receiver
		with: #()! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'OliFlueckiger 5/5/2011 18:41'!
visitUnarySelector: aUnarySelector
! !

!P4AST2TAC methodsFor: 'visitor' stamp: 'CamilloBruni 2/6/2012 14:06'!
visitVariableNode: anASTVariable
	^ builder local: anASTVariable name ifAbsent: [
		builder instVarOrGlobal: anASTVariable name]! !
